package massim.javaagents.agents;

import apltk.interpreter.data.LogicBelief;
import apltk.interpreter.data.LogicGoal;
import apltk.interpreter.data.Message;
import eis.iilang.Action;
import eis.iilang.Parameter;
import eis.iilang.ParameterList;
import eis.iilang.Percept;
import massim.javaagents.Agent;
import massim.javaagents.agents.util.map.CityMap;
import massim.javaagents.agents.util.map.Location;
import massim.javaagents.agents.util.map.Route;

import java.io.*;
import java.util.*;

/**
 * Created by sd.
 */
public class TestAgent extends Agent {

    private FileWriter out;
    private BufferedReader teamIn;

    private int lastStep = -1;
    private Action lastAction;
    private int simCounter = 1;

    private String name = "";

    private File logpath;
    private File logfile;
    private File teamconfig;
    private File teamlog;

    private String map = "";
    static CityMap cityMap;
    private double lon = 0.0d;
    private double lat = 0.0d;

    public static long time = System.currentTimeMillis()/1000; //make sure all agents log to the same folder
    
    Set<String> perms = new HashSet<>();
    
    private boolean mapReady = false;

    private String inFacility = ""; //for percept inFacility
    private int charge = 500; //for percept charge
    private int batteryCapacity = 0; //for percept batteryCapacity
    private double latitude = 0; //for percept lat
    private double longitude = 0; //for percept lon
    private String lastActionResult = ""; //for percept lastActionResult
    private String lastActionParam = ""; //for percept lastActionParam
    private String role = ""; //for percept role
    private LinkedList<String> jobsTaken = new LinkedList<String>(); //for percept jobTaken
    private boolean jobTaken = false;
    private int loadCapacity = 0; //for percept loadCapacity
    private String id = ""; //for percept id
    private int money = 0;
    private int currentStep = 0;
    private int speed=0;
    private LinkedList<String> usableTools = new LinkedList<String>();
    private int steps = 0;
    
    private LinkedList<LinkedList<Parameter>> entities = new LinkedList<LinkedList<Parameter>>(); //for percept entity
    private LinkedList<LinkedList<Parameter>> pricedJobs = new LinkedList<LinkedList<Parameter>>(); //for percept pricedJob
    private LinkedList<LinkedList<Parameter>> products = new LinkedList<LinkedList<Parameter>>(); //for percept product
    private LinkedList<LinkedList<Parameter>> shops = new LinkedList<LinkedList<Parameter>>(); // for percept shop
    private LinkedList<LinkedList<Parameter>> chargingStations = new LinkedList<LinkedList<Parameter>>(); //for percept chargingStation
    private LinkedList<LinkedList<Parameter>> visibleChargingStations = new LinkedList<LinkedList<Parameter>>(); //for percept visibleChargingStation
    private LinkedList<LinkedList<Parameter>> items = new LinkedList<LinkedList<Parameter>>(); //for percept item
    private LinkedList<LinkedList<Parameter>> oldItems = new LinkedList<LinkedList<Parameter>>(); //to remember last value of items
    private LinkedList<LinkedList<Parameter>> workshops = new LinkedList<LinkedList<Parameter>>(); //for percept workshop
    private LinkedList<LinkedList<Parameter>> storages = new LinkedList<LinkedList<Parameter>>(); //for percept storage
    private LinkedList<LinkedList<Parameter>> dumps = new LinkedList<LinkedList<Parameter>>(); //for percept dump
    
    private LinkedList<Vector<String>> shopBeliefs = new LinkedList<Vector<String>>(); //for belief shopi, i=0,...,n
    private LinkedList<Vector<String>> roleInfo = new LinkedList<Vector<String>>(); //for belief agentInfo, contains all information from percept role
    private LinkedList<LinkedList<Vector<String>>> jobPlans = new LinkedList<LinkedList<Vector<String>>>();
    private LinkedList<LinkedList<String>> allMyAgents = new LinkedList<LinkedList<String>>();
    private LinkedList<LinkedList<LinkedList<String>>> myAgentTeams = new LinkedList<LinkedList<LinkedList<String>>>();
    
    private LinkedList<Vector<String>> allMyItems = new LinkedList<Vector<String>>();
    private LinkedList<LinkedList<Parameter>> allMyChargingStations = new LinkedList<LinkedList<Parameter>>(); //chargingStations + visibleChargingStations
    
    private String myJob = "none";
    private LinkedList<String> myJobs = new LinkedList<String>();
    
    private boolean recharging = false;
    private int cooperationA = 1;
    private int cooperationB = 1;
    private boolean costsBeforeTime = false; //defines which kind of strategy the agents use to execute jobs
    private boolean buyAssembledItems = false; //assembled items are bought instead of assembled
    private boolean checkJobConditions = true;
    private boolean auction = false;
    private LinkedList<String> allMyTools = new LinkedList<String>();
    private int numberOfTools = 0;
    private boolean lookingForJob = false;
    private boolean executingJob = false;
    private boolean[] executingJobTeams;
    private boolean assembling = false;
    private String currentAssembler = "none";
    private boolean teamMode = false;
    private int agentsPerTeam = 8; //possible inputs: 4,8 
    private String coordinatorA = "A3";
    private String coordinatorB = "B3";
    private int acknowledgement = 0;
    private int numberOfShopBeliefs = 0;
    private LinkedList<Parameter> cheapestWorkshop = new LinkedList<Parameter>();
    private boolean itemsStored = false;
    private boolean checkCharge = false;
    private boolean sendItems = false;
    private String nextDestination = "none";
    private String currentStorage = "none";
    private LinkedList<String> rejectedJobs = new LinkedList<String>();
    private LinkedList<LinkedList<String>> itemLevels= new LinkedList<LinkedList<String>>();
    private HashMap<String,Integer> itemDepth = new HashMap<String,Integer>();
    private int currentJobEnd = 10000;
    
    private int numberOfAgents = 16;
    private String coordinator;
    private boolean checkJobTimeLeft = false;
    private boolean checkSimTimeLeft = false;
    private int timeMin = 50;
    private int jobSafetyFactor = 0;
    private boolean doNothing = false;
    private boolean log = false;
    private int maxItemDepth =20;
    
    protected Stack<LogicGoal> myGoals;
   
    /**
     * Initializes an agent with a given name. Ensures that the name is unique.
     *
     * @param name is the name of the agent
     * @param team is the team of the agent
     */
    public TestAgent(String name, String team) {

        super(name, team);

        this.name = name;

        myGoals = new Stack<LogicGoal>();
        
        coordinator = getTeam() + "1"; //default value
        
        createIO();
    }

    private void createIO() {
        logpath = new File("perceptlog/"+System.currentTimeMillis()/(1000*1000));
        logfile = new File(logpath+"/"+name+"-"+simCounter);
        teamconfig = new File("teamconfig"+getTeam());
        //teamlog = new File("teamlog/"+getTeam()+"_"+System.currentTimeMillis()/(1000*100));

        logpath.mkdirs();

        if(!teamconfig.exists()) try {
            teamconfig.createNewFile();
        } catch (IOException e) {
            e.printStackTrace();
        }

        try {

            teamIn = new BufferedReader(new FileReader(teamconfig));
            String line;
        	while( (line = teamIn.readLine()) != null) {
        		line = line.replaceAll("\\s", "");
        		int index = line.indexOf("=");
            	if(index != -1){
            		String parameter = line.substring(0, index);
            		String value = line.substring(index+1, line.length());
            		switch(parameter){
            			case "numberOfAgents":
            				numberOfAgents = Integer.parseInt(value);
            				break;
            			case "coordinator":
            				if(Integer.parseInt(value.substring(1, value.length()))<=numberOfAgents){
                				coordinator = value;
            				}else{
            					coordinator = new String(getTeam() + "1");
            				}
            				break;
            			case "teamMode":
            				teamMode = value.matches("true");
            				break;
            			case "agentsPerTeam":
            				agentsPerTeam = Integer.parseInt(value);
            				break;
            			case "checkJobConditions":
            				checkJobConditions = value.matches("true");
            				break;
            			case "checkJobTimeLeft":
            				checkJobTimeLeft = value.matches("true");
            				break;
            			case "checkSimTimeLeft":
            				checkSimTimeLeft = value.matches("true");
            				break;
            			case "timeMin":
            				timeMin = Integer.parseInt(value);
            				break;
            			case "buyAssembledItems":
            				buyAssembledItems = value.matches("true");
            				break;
            			case "doNothing":
            				doNothing = value.matches("true");
            				break;
            			case "jobSafetyFactor":
            				jobSafetyFactor = Integer.parseInt(value);
            				break;
            			case "log":
            				log = value.matches("true");
            				//println("log="+log);
            				break;
            			case "maxItemDepth":
            				maxItemDepth = Integer.parseInt(value);
            				break;
        				default:
        					println("error: unknown parameter! parameter=" + parameter);
        					writeInLog("Error in TeamConfig: unknown parameter! Use default value!");
        					break;
            		}
                }
                else{
                	println("Error in teamconfig! '=' expected!");
                	writeInLog("Error in TeamConfig: '=' expected! Use default value!");
                }	
        	}
            teamIn.close();
            teamIn = null;
            
            /*//team log
            if(getName().equals("agent"+coordinator)){
            	println("write in teamlog");
                //out.write("-"+getTeam() + " starting log at " + System.currentTimeMillis());
            	out.write("Team:"+getTeam());
                out.write("\n \n");
                out.flush();
                println("wrote in teamlog");
            }*/
            
            if(getName().equals("agent"+coordinator) && log==true){
            	teamlog = new File("teamlog/"+getTeam()+"_"+System.currentTimeMillis()/(1000*100));
                
                if(!teamlog.exists()) try {
                	println("create new file for teamlog");
                	teamlog.createNewFile();
                } catch (IOException e) {
                	e.printStackTrace();
                }
                
                out = new FileWriter(teamlog);
                
                Date currentDate = new Date();
                out.write("Simulation:"+currentDate.toString());
                out.write(" -Team"+getTeam());
                out.write("\n");
            }
            

        } catch (IOException e) {
            e.printStackTrace();
        }
       
    }

    public Action step() {
    
    	//for testing:
    	final long timeStart = System.currentTimeMillis();
    	
        boolean newStep = true;

        //log percepts
        //if(out != null){

           /* try {
                out.write("Log: ");
            } catch (IOException e) {
                e.printStackTrace();
            }
*/
            Collection<Percept> percepts = getAllPercepts();

            entities.clear();
            pricedJobs.clear();
            products.clear();
            shops.clear();
        	chargingStations.clear();
        	visibleChargingStations.clear();
        	allMyChargingStations.clear();
        	oldItems.clear();
        	oldItems = items;
        	items.clear();
        	jobsTaken.clear();
        	workshops.clear();
        	usableTools.clear();
        	storages.clear();
        	dumps.clear();
            
            for(Percept p: percepts){
                /*try {
                  //  out.write(p.toProlog());
                	out.write(p.toXML());
                } catch (IOException e) {
                    e.printStackTrace();
                }*/

                if(p.getName().equals("step")){
                    int step = new Integer(p.getParameters().get(0).toProlog()).intValue();
                    currentStep = step;
                    
                    println("steps="+steps);
                    println("currentStep="+currentStep);
                    if(steps-1==currentStep){
                    	writeInLog("Last Step! Money="+money);
                    }

                    if(step < lastStep){
                        simCounter++;
                        createIO();
                        
                        //remove all parameters from last simulation
                        getMyGoalBase().clear();
                        getBeliefBase().clear();
                        oldItems.clear();
                        shopBeliefs.clear();
                        roleInfo.clear();
                        jobPlans.clear();
                        myGoals.clear();
                        jobsTaken.clear();
                        allMyAgents.clear();
                        cheapestWorkshop.clear();
                        
                        lookingForJob = false;
                        executingJob = false;
                        assembling = false;
                        recharging = false;
                        auction = false;
                        mapReady = false;
                        jobTaken = false;
                        
                        numberOfTools = 0;
                        acknowledgement = 0;
                        
                        myJob = "none";
                        
                        println("New simulation!");
                        
                    }
                    else if(step == lastStep){
                        newStep = false;
                    }
                    lastStep = step;
                }
                else if(p.getName().equals("inFacility")){
             	   inFacility = p.getParameters().get(0).toString(); 
                }
                 
                else if(p.getName().equals("charge")){
                   charge = new Integer (p.getParameters().get(0).toProlog()).intValue();                   
                }
                else if(p.getName().equals("lat")){
                    latitude = new Double (p.getParameters().get(0).toProlog());                 
                }
                else if(p.getName().equals("lon")){
                    longitude = new Double (p.getParameters().get(0).toProlog()); 
                }
                else if(p.getName().equals("lastActionResult")){
                    lastActionResult = p.getParameters().get(0).toString();   
                }
                else if(p.getName().equals("lastActionParam")){
                	lastActionParam = p.getParameters().get(0).toString();
                }
                else if(p.getName().equals("role")){         	
                    role = p.getParameters().get(0).toString();  
                    speed = new Integer(p.getParameters().get(1).toProlog()).intValue();
                    loadCapacity = new Integer(p.getParameters().get(2).toProlog()).intValue();
                    batteryCapacity = new Integer(p.getParameters().get(3).toProlog()).intValue();
                    for(Parameter param: (ParameterList) p.getParameters().get(4)){
                    	usableTools.add(param.toString());
                    }
                }
                else if(p.getName().equals("entity")){
                       entities.add(p.getParameters());        
                   }
                else if(p.getName().equals("pricedJob")){                    
                    pricedJobs.add(p.getParameters());        
                }
                else if(p.getName().equals("product")){                     
                    products.add(p.getParameters());        
                }
                else if(p.getName().equals("shop")){
                 shops.add(p.getParameters());        
                }
                else if(p.getName().equals("jobTaken")){
                	jobsTaken.add(p.getParameters().get(0).toString());
                }
                else if(p.getName().equals("chargingStation")){
                	chargingStations.add(p.getParameters());
                }
                else if(p.getName().equals("visibleChargingStation")){
                	visibleChargingStations.add(p.getParameters());
                }
                else if(p.getName().equals("item")){
                	items.add(p.getParameters());
                }
                else if(p.getName().equals("workshop")){
                	workshops.add(p.getParameters());
                }
                else if(p.getName().equals("storage")){
                	storages.add(p.getParameters());
                }
                else if(p.getName().equals("dump")){
                	dumps.add(p.getParameters());
                }
                else if(p.getName().equals("map")){
                	map = p.getParameters().get(0).toString();
                }
                else if(p.getName().equals("money")){
                	money = new Integer(p.getParameters().get(0).toProlog()).intValue();
                }
                else if(p.getName().equals("steps")){
                	steps = new Integer(p.getParameters().get(0).toProlog()).intValue();
                }
            }
           /* try {
                out.write("\n \n");
            } catch (IOException e) {
                e.printStackTrace();
            }*/
        //}
        
        println("number of chargingStations=" + chargingStations.size());
        println("number of visibleChargingStations=" + visibleChargingStations.size());
        allMyChargingStations = new LinkedList<LinkedList<Parameter>>(chargingStations);
        if(!visibleChargingStations.isEmpty()){
        	for(LinkedList<Parameter> myChargingStation: visibleChargingStations){
        		allMyChargingStations.add(myChargingStation);
        	}
        }
        
        //launch graphhopper if possible
        if(!mapReady && !map.equals("")){
            //FIXME change this if cellsize and/or proximity change
            cityMap = new CityMap(map, 0.001, 0.0002);
            if(role.equals("Drone")){
            	perms.add("air");
            }else{
                perms.add("road");
            }
            println("perms=" + perms);
//            Route route = cityMap.getNewRoute(
//                    new Location(longitude, latitude), new Location(-0.1368d,51.4872d), perms);
//
//            println("Found route of length " + route.getRouteDuration(1));
            mapReady=true;
        }
        
        if(doNothing==true){
        	println("do nothing");
        	return lastAction=CityUtil.action("skip");
        }
        
        println("Team=" + getTeam());
        if(getTeam().equals("B")){
        	Collections.reverse(pricedJobs);
        }
        
        /*if(getName().equals("agent"+coordinator)){
        	writeInLog("Step "+currentStep+":");
        }*/
        
        //beliefs
        
        //share role information
        if(currentStep==0){
        	LinkedList<String> roleParameters = new LinkedList<String>();
        	roleParameters.add(role);
        	roleParameters.add(new Integer(speed).toString());
        	roleParameters.add(new Integer(loadCapacity).toString());
        	roleParameters.add(new Integer(batteryCapacity).toString());
        	for(String tool: usableTools){
        		roleParameters.add(tool);
        	}
        	LogicBelief roleInformation = new LogicBelief(role, roleParameters);
        	broadcastBelief(roleInformation);
        	addBelief(roleInformation);
        	println("share info " + getName());
        	
        	LogicBelief log = new LogicBelief("log"+getName(), getName()+": "+getName());
    		sendMessage(log, "agent"+coordinator);
    		println("send name");
        	
        	//coordinator: 
        	if(getName().equals("agent"+coordinator)){
            	//writeInLog("Team "+getTeam());
            	//print products
        		println("products:");
        		Vector<String> productLog = new Vector<String>();
            	for(LinkedList<Parameter> product: products){
            		println(product);
            		productLog.add(product.toString());
            	}
            	writeInLog(productLog);
            	
            	
            	//sort products by level
            	//LinkedList<LinkedList<String>> itemLevels= new LinkedList<LinkedList<String>>();
            	LinkedList<LinkedList<Parameter>> allProducts = new LinkedList<LinkedList<Parameter>>(products);
            	//build level 0
            	LinkedList<String> level0 = new LinkedList<String>();
            	LinkedList<LinkedList<Parameter>> level0Products = new LinkedList<LinkedList<Parameter>>();
            	for(LinkedList<Parameter> product: allProducts){
            		ParameterList parameter = (ParameterList) product.get(2);
            		if(parameter.isEmpty()){
            			level0.add(product.get(0).toString());
            			level0Products.add(product);
            		}
            	}
            	itemLevels.add(level0);
            	for(LinkedList<Parameter> product:level0Products){
            		allProducts.remove(product);
            	}
            	//build other levels
            	LinkedList<String> level = new LinkedList<String>();
            	LinkedList<LinkedList<Parameter>> levelProducts = new LinkedList<LinkedList<Parameter>>();
            	//for all levels
            	for(int i=0; i<products.size();i++){
            		if(allProducts.isEmpty()){
            			break;
            		}
            		//for all products
            		for(LinkedList<Parameter> product: allProducts){
            			boolean contains = false;
            			ParameterList parameter = (ParameterList) product.get(2);
            			//for every component
            			for(Parameter p: parameter){
            				//check if component is in one of the lower levels
            				for(int j=0; j<=i;j++){
            					//println("item:"+itemLevels.get(j)+"vs"+getInfo(p.toString()).get(1));
            					if(itemLevels.get(j).contains(getInfo(p.toString()).get(1))){
            						contains = true;
            						//println("contains true");
            						break;
            					}
            					contains = false;
            				}
            				if(contains==false){
            					break;
            				}
            			}
            			if(contains==true){
            				//println("add to level");
            				level.add(product.get(0).toString());
            				levelProducts.add(product);
            			}
            		}
            		LinkedList<String> levelx = new LinkedList<String>(level);
            		itemLevels.add(levelx);
            		//println("item levels:" + itemLevels.toString());
            		for(LinkedList<Parameter> product:levelProducts){
            			allProducts.remove(product);
            		}
            		level.clear();
            		levelProducts.clear();
            		//println("item levels 2:" + itemLevels.toString());
            	}
            	
            	Vector<String> levelLog = new Vector<String>();
            	println("product levels:");
            	for(LinkedList<String> levelx: itemLevels){
            		println(levelx.toString());
            		levelLog.add(levelx.toString());
            	}
            	writeInLog(levelLog);
            	println("productssize="+products.size());
            	
            	for(int i=0; i<itemLevels.size();i++){
            		for(String item:itemLevels.get(i)){
            			itemDepth.put(item, i);
            		}
            	}
            	
            	println("depth:");
            	for(LinkedList<Parameter> product:products){
            		println(product.get(0).toString()+":"+itemDepth.get(product.get(0).toString()));
            	}
            	
            	
            	
            	println("numberOfAgents=" + numberOfAgents);
            	println("coordinator=" + coordinator);
            	println("teamMode=" + teamMode);
            	println("agentsPerTeam=" + agentsPerTeam);
            	println("checkJobConditions=" + checkJobConditions);
        	}
        	
        }
        
        //update shop beliefs
        
        //try to remove belief with predicate inFacility from beliefs and check if list got smaller
        int beliefSize = getBeliefBase().size();
        println("beliefSize" + beliefSize);
    	removeBeliefs(inFacility);
    	println("beliefSize" + getBeliefBase().size());
    	println(inFacility.substring(0,2) + " = " + "sh");
        if(inFacility.substring(0,2).equals("sh")){
        	if(getBeliefBase().size() == beliefSize){
        		//send message to coordinator
        		LogicBelief ack = new LogicBelief("ack"+getName(), getName());
        		if(getName().equals("agent"+coordinator)){
        			addBelief(ack);
        			println("add ack");
        		}else{
        			sendMessage(ack, "agent"+coordinator);
        			println("send ack");
        		}
        	}
        	LinkedList<String> parameters = new LinkedList<String>();
        	for(LinkedList<Parameter> shop: shops){
        		if(shop.get(0).toString().equals(inFacility)){
        			for(Parameter p:shop){
        				if(p instanceof ParameterList){
        					for(Parameter param: (ParameterList) p){
        						parameters.add(param.toString());			
        					}
        				}else{
            				parameters.add(p.toString());
    					}	
        			}
        		}
        	}
        	LogicBelief shop = new LogicBelief("shop"+inFacility.substring(4), parameters);
        	broadcastBelief(shop);
        	addBelief(shop);
        }
        
        //check messages
        Collection<Message> newMessages = getMessages();
        for(Message message: newMessages){
        	LogicBelief belief = (LogicBelief) message.value;
        	removeBeliefs(belief.getPredicate());
        	addBelief(belief);
        	if(belief.getPredicate().equals("ack")){
        		println("message ack");
        	}
        }
        
        //check beliefs
        Collection<LogicBelief> beliefs = getBeliefBase();
        LinkedList<Vector<String>> currentPlans = new LinkedList<Vector<String>>();
        LinkedList<String> currentAcks = new LinkedList<String>();
        shopBeliefs.clear();
        roleInfo.clear();
        for(LogicBelief b:beliefs){
        	println("belief:"+b.getPredicate());
        	if(b.getPredicate().length() >= 5){
            	if(b.getPredicate().substring(0, 4).equals("shop")){
            		shopBeliefs.add(b.getParameters());
            	}
            	else if(b.getPredicate().substring(0, 4).equals("plan")){
            		println("plan: " + b.getParameters());
            		currentPlans.add(b.getParameters());
            		println("currentPlansIsEmpty=" + currentPlans.isEmpty());
            		removeBeliefs(b.getPredicate());
            	}
            	else if(b.getPredicate().substring(0,3).equals("ack")){
            		acknowledgement++;
            		println("acks=" + acknowledgement);
            		currentAcks.add(b.getPredicate());
            	}
            	else if(b.getPredicate().equals("Drone")){
            		if(currentStep==1){
            			println("got role info drone");
            		}
            		roleInfo.add(b.getParameters());
            	}
            	else if(b.getPredicate().equals("Truck")){
            		if(currentStep==1){
                		println("got role info truck");
            		}
            		roleInfo.add(b.getParameters());
            	}
            	
            	else if(b.getPredicate().equals("Motorcycle")){
            		if(currentStep==1){
                		println("got role info motorcycle");
            		}
            		roleInfo.add(b.getParameters());
            	}
            	else if(b.getPredicate().equals("gotoShop")){
              	   LogicGoal gotoShop = new LogicGoal("goto", b.getParameters().get(0));
             	   addMyGoal(gotoShop);
             	   removeBeliefs(b.getPredicate());
            	}
            	else if(b.getPredicate().substring(0,5).equals("items")){
            		allMyItems.add(b.getParameters());
            		println("items:" + b.getParameters());
            		removeBeliefs(b.getPredicate());
            	}
            	else if(b.getPredicate().substring(0, 3).equals("log")){
            		writeInLog(b.getParameters());
            		removeBeliefs(b.getPredicate());
            		println("log");
            	}
            	else if(b.getPredicate().length() >= 9){
            		println(b.getPredicate().substring(0,7));
            		if(b.getPredicate().substring(0,7).equals("assist_")){
                		println("Beliefparameter=" + b.getParameters().get(2).substring(6) + " currentAssembler=" + currentAssembler.substring(1));
                		if(b.getParameters().get(2).substring(6).equals(currentAssembler.substring(1))){
                			assembling = true;
                		}
                		println("assembling=" + assembling);
                		println("currentAssembler=" + currentAssembler);
        				removeBeliefs(b.getPredicate());
                	}
                	else if(b.getPredicate().substring(0,9).equals("assemble_")){
                		if(getMyGoalBase().isEmpty()){
                			println("Error! Assembling without assistant!");
                			if(getName().equals("agent" + coordinator)){
             	    			writeInLog(getName()+": Assist Assemble Error!");
             	    		}else{
             	    			LogicBelief log = new LogicBelief("log"+getName(), getName()+": Assist Assemble Error!");
             	    			sendMessage(log, "agent"+coordinator);
             	    			println("send Message");
             	    		}
                		}else{
                			if(getMyGoalBase().peek().getPredicate().equals("assist_assemble") && getMyGoalBase().peek().getParameters().get(0).equals(b.getParameters().get(0))&&getMyGoalBase().peek().getParameters().get(1).equals(b.getParameters().get(1))){
                				assembling = false;
                				println("assembling=" + assembling);
                				removeBeliefs(b.getPredicate());
                			}
                		}
                	}
            	}
        	}
        	else if(b.getPredicate().equals("Car")){
        		if(currentStep==1){
            		println("got role info car");
        		}
        		roleInfo.add(b.getParameters());
        	}
        }
        println("beliefbase=" + getBeliefBase().size());
        for(String currentAck: currentAcks){
            removeBeliefs(currentAck);
        }
        println("beliefbase=" + getBeliefBase().size());
        
        if(getName().equals("agent" + coordinator)){
        	if(currentStep>=109 && currentStep<=119){
        		println("AllMyItems=");
                for(Vector<String> agentItems: allMyItems){
                    println(agentItems);
                }
        	}
        }
        
        //coordinator only:
        println("lookingForJob=" + lookingForJob);
        if(getName().equals("agent" + coordinator) && teamMode == true && lookingForJob == true){
        	println("myAgentTeams.size=" + myAgentTeams.size());
        	for(int team=0; team< myAgentTeams.size(); team++){
        		println("myAgentTeams.size=" + myAgentTeams.size());
        		println("team=" + team);
        		LinkedList<LinkedList<String>> myAgentTeam = myAgentTeams.get(team);
        		println("executingJobTeams=" + executingJobTeams[team]);
        		if(executingJobTeams[team]==true){
        			//executing job
        			boolean available = false;
            		for(int i=0; i< pricedJobs.size(); i++){
                		LinkedList<Parameter> job = pricedJobs.get(i);
                		if(job.get(0).toString().equals(myJobs.get(team))){
                			available = true;
                			break;
                		}
                	}
            		if(available == false){
            			println("currentJobEnd="+currentJobEnd);
            			println("currentStep="+currentStep);
            			if(currentJobEnd<=currentStep){
            				println("Job was cancelled!");
            				writeInLog(getName()+": "+myJobs.get(team)+" was cancelled!");
            			}else{
            				println("Job was completed by one of the teams!");
            				writeInLog(getName()+": "+myJobs.get(team)+" was completed by one of the teams!");
            			}
            			//println("job was cancelled or completed by other team");
            			println("job no longer available!");
            			executingJobTeams[team] = false;	
            			
            			for(LinkedList<String> myAgent: myAgentTeams.get(team)){
            				if(myAgent.get(0).equals(coordinator)){
             				   //remove all goals for current job from stack
             				   if(getMyGoalBase().isEmpty()==false){
             					   println(getMyGoalBase().peek().getPredicate());
             					   while(getMyGoalBase().peek().getPredicate().equals("executeJob")==false){
             						   removeMyGoal();
             					   }
             					   removeMyGoal();
             				   }
             			   }
             		   }
            			
            			
            		}else{
                    	//continue with goals
            			println("job still available");
            		}
        		}
        		else if(executingJobTeams[team]==false){
        			//looking for job
        			println("ack=" + acknowledgement + " < " + numberOfShopBeliefs);
            		if(acknowledgement < numberOfShopBeliefs){//number of agents
            			println("waiting for acknowledgement!");
            			println("acknowledgement=" + acknowledgement);
            			//return lastAction=CityUtil.action("skip");
            		}else{
            			
            			//check time left before simulation is over
            	    	if(checkSimTimeLeft == true){
            	    		if(steps - currentStep < timeMin){
            	    			println("sim end:" + steps+ ", current step:" + currentStep);
            	    			println("Not enough time left until simulation is over!");
                    			executingJob = false;
                    			println("executingJob = false");
                    			//return lastAction=CityUtil.action("skip");
            	    		}
            	    	}
            			
            			println("checkJobs");
                		if(pricedJobs.isEmpty()){
                			println("skip4.2");
                			println("pricedJobs: empty");
                			//return lastAction=CityUtil.action("skip"); 
                		}else{
                    	    //check every job in the pricedJob list, stop if a job is taken  
                        	boolean newJob = false;
                			for(int i=0; i< pricedJobs.size(); i++){
                        		LinkedList<Parameter> job = pricedJobs.get(i);
                        		//check if job has been rejected
                        		boolean jobRejected = false;
                        		for(String rejectedJob: rejectedJobs){
                        			println("test:" + rejectedJob + "=" + job.get(0).toString());
                        			if(rejectedJob.equals(job.get(0).toString())){
                        				jobRejected = true;
                        				break;
                        			}
                        		}
                        		if(jobRejected==true){
                        			continue;
                        		}
                        		//check if job was already taken by one of the other teams
                        		boolean taken = false;
                        		for(int j=0; j<myJobs.size(); j++){
                        			println(myJobs.get(j) + " = " + job.get(0));
                        			if((myJobs.get(j).toString()).equals(job.get(0).toString())){
                        				taken = true;
                        				break;
                        			}
                        		}
                        		//if job is already taken: continue with next job
                        		if(taken==true){
                        			continue;
                        			
                        		}
                        		if(checkJob(job, team)==true){
                        		   //add new Job
                        		   newJob = true;
                        		   myJobs.set(team, job.get(0).toString());
                        		   executingJobTeams[team] = true;
                        		   for(LinkedList<String> myAgent: myAgentTeams.get(team)){
                        			   if(myAgent.get(0).equals(coordinator)){
                        				   LogicGoal executeJob = new LogicGoal("executeJob", job.get(0).toString());
                                       	   addMyGoal(executeJob); 
                                       	   LogicGoal wait = new LogicGoal("wait");
                                       	   addMyGoal(wait); 
                                       	   //return checkGoals(newStep);
                        			   }
                        		   }
                        		   break;
                               	   
                        		}
                        	}
                			if(newJob == false){
                				println("no new job found");
                            	//println("skip5.2");
                        		//return lastAction=CityUtil.action("skip"); 
                			} 
                		} 
            		}
        		}
        	}
        	
        }
        
        //create job goals
        println("currentPlansIsEmpty=" + currentPlans.isEmpty());
        if(currentPlans.isEmpty()){
        	if(executingJob == true){
            	println(getName() + " executing job");
            	
            	//check if job is still available
        		boolean available = false;
        		for(int i=0; i< pricedJobs.size(); i++){
            		LinkedList<Parameter> job = pricedJobs.get(i);
            		println(job.get(0).toString() + "==" + myJob + " : " + job.get(0).toString().equals(myJob));
            		if(job.get(0).toString().equals(myJob)){
            			available = true;
            			break;
            		}
            	}
        		//if(available == false && recharging == false){
        		if(available == false){
        			
        			println("currentJobEnd="+currentJobEnd);
        			println("currentStep="+currentStep);
        			if(getName().equals("agent" + coordinator)){
	        			if(currentJobEnd<=currentStep){
	        				println("Job was cancelled!");
	        				writeInLog(getName()+": "+myJob+" was cancelled!");
	        			}else{
	        				println("Job was completed by one of the teams!");
	        				writeInLog(getName()+": "+myJob+" was completed by one of the teams!");
	        			}
        			}else{
        				println("job was cancelled or completed by one of the teams!");
        			}
        			
        			println("job no longer available!");
        			
        			String action = lastAction.getName();
        			println("lastAction="+action);
        			if(action.equals("deliver_job")){
             	    	if(lastActionResult.equals("successful")){
             	    		if(getName().equals("agent" + coordinator)){
             	    			writeInLog(getName()+": "+getMyGoalBase().peek().getParameters().get(0)+" was successfully delivered in step "+currentStep+"! money="+money);
             	    		}else{
             	    			LogicBelief log = new LogicBelief("log"+getName(), getName()+": "+getMyGoalBase().peek().getParameters().get(0)+" was successfully delivered in step "+currentStep+"! money="+money);
             	    			sendMessage(log, "agent"+coordinator);
             	    			println("send Message");
             	    		}
             	    	}
        			}

        			//remove all goals for current job from stack
        			if(recharging == false){
        				if(getMyGoalBase().isEmpty()==false){
            				println(getMyGoalBase().peek().getPredicate());
            				if(getMyGoalBase().peek().getPredicate().equals("checkJobs")==false){
                				while(getMyGoalBase().peek().getPredicate().equals("executeJob")==false){
                    				removeMyGoal();
                    			}
            				}
            			}
        			}
        			
        			
        			//send item info to coordinator
        			if(sendItems==false){
        				Vector<String> myItems = new Vector<String>();
            			myItems.add(getName());
            			for(LinkedList<Parameter> item: items){
            				myItems.add(item.get(0).toString());
            				myItems.add(item.get(1).toString());
            			}
            			LogicBelief items = new LogicBelief("items" + getName(), myItems);
            			println("items=" + items.getParameters());
            			if(getName().equals("agent" + coordinator)){
            				addBelief(items);
            				println("add items");
            			}else{
            				sendMessage(items, "agent" + coordinator);
            				println("send items");
            			}
            			executingJob=false;
            			sendItems=true;
        			}
        			
        			
        			
        			if(getName().equals("agent" + coordinator)){
        				println("wait");
            			LogicGoal wait = new LogicGoal("wait");
                		addMyGoal(wait);
        			}
        			
        			
        		}else{
                	//continue with goals
        			if(recharging==true){
        				println("agent is recharging");
        			}else{
            			println("job still available");
        			}
        		}
        		if(getMyGoalBase().isEmpty() == false){
            		if(getMyGoalBase().peek().getPredicate().equals("checkJobs")){
                		println("wait");
            			LogicGoal wait = new LogicGoal("wait");
                		addMyGoal(wait);
            		}
        		}
            	
        	}else{
            	println(getName() + " has no new job");
        	}
        	
        }else{
        	println(getName() + " execute job");
        	executingJob = true;
        	checkCharge = false;
        	sendItems = false;
        	if(getMyGoalBase().isEmpty() == false){
        		println("predicate=" + getMyGoalBase().peek().getPredicate());
        		if(getMyGoalBase().peek().getPredicate().equals("charge")){ //if charge goal is on top of the stack
            		LogicGoal tmpGoal = getMyGoalBase().peek();
            		println("current goal = " + tmpGoal);
            		removeMyGoal();
            		println("current goal = " + tmpGoal);
            		//insert removeJobGoals
                	LogicGoal executeJob = new LogicGoal("executeJob", currentPlans.get(0).get(0));
                	addMyGoal(executeJob);
                	addMyGoal(tmpGoal);
            	}else if(getMyGoalBase().peek().getPredicate().equals("goto") && getMyGoalBase().peek().getParameters().get(0).toString().substring(0, 11).equals("facility=ch")){ //if goto goal with destination charging statio is on top of the stack
            		LogicGoal tmpGoal = getMyGoalBase().peek();
            		println("current goal = " + tmpGoal);
            		removeMyGoal();
            		println("current goal = " + tmpGoal);
            		LogicGoal tmpGoal2 = getMyGoalBase().peek();
            		println("current goal = " + tmpGoal2);
            		removeMyGoal();
            		println("current goal = " + tmpGoal2);
            		//insert removeJobGoals
                	LogicGoal executeJob = new LogicGoal("executeJob", currentPlans.get(0).get(0));
                	addMyGoal(executeJob);
                	addMyGoal(tmpGoal2);
                	addMyGoal(tmpGoal);
            	}else{ //if another goal is on top of the stack
            		println("current goal is no recharge goal");
            		//insert removeJobGoals
                	LogicGoal executeJob = new LogicGoal("executeJob", currentPlans.get(0).get(0));
                	addMyGoal(executeJob);
            	}
        	}else{ //if no goal is in the stack
        		LogicGoal executeJob = new LogicGoal("executeJob", currentPlans.get(0).get(0));
            	addMyGoal(executeJob);
        	}
            
        	println("filling JobPlans");
    		jobPlans.add(currentPlans);
    		println("jobPlansIsEmpty=" + jobPlans.isEmpty());
        }
        

        if(currentStep==1){

            //cordinator: print role info
        	if(getName().equals("agent"+coordinator)){
            	println("role Info:");
            	for(Vector<String> info: roleInfo){
            		writeInLog(info.toString());
            		println(info);
            	}
        	}
        	
        	//get the cheapest workshop
      	   int wsPrice = 0;
      	   
      	   for(LinkedList<Parameter> workshop: workshops){
      		   if(new Integer(workshop.get(3).toProlog()).intValue() <= wsPrice){
      			   wsPrice = new Integer(workshop.get(3).toProlog()).intValue();
      			   cheapestWorkshop = workshop;
      		   }
      	   }
      	   
      	   //check how many tools exist in the current scenario
      	   Set<String> myTools = new HashSet<>();
      	   for(Vector<String> info: roleInfo){
      		   for(int i=4; i<info.size(); i++){
      			   myTools.add(info.get(i));
      		   }
      	   }
      	   numberOfTools = myTools.size();
      	   //allMyTools = myTools.toArray(new String[0]);
      	   for(String tool:myTools){
      		   allMyTools.add(tool);
      	   }
      	   
      	   println("numberOfTools=" + numberOfTools);
      	   for(int i=0; i<allMyTools.size(); i++){
      		   println(allMyTools.get(i));
      	   }
        	
        	allMyAgents = getListOfAgents();
      	   
      	   
      	   if(teamMode == true){
      		   
      		   myAgentTeams = getAgentTeams(allMyAgents);
          	   
          	   lookingForJob = true;
          	   println("lookingForJob=" + lookingForJob);
          	   executingJobTeams = new boolean[myAgentTeams.size()];
          	   for(int i=0; i<executingJobTeams.length; i++){
          		   executingJobTeams[i] = false;
          	   }
          	   for(int i=0; i<myAgentTeams.size(); i++){
          		   myJobs.add("0");
          	   }
      	   }
      	   
      	   //get Shop Beliefs
      	   if(getName().equals("agent"+coordinator)){
          	   
          	   println("All my agents:");
          	   for(LinkedList<String> myAgent: allMyAgents){
          		   println(myAgent);
          	   }
      		   
      		   getShopBeliefs();
      	   }
        	
        	
        }
      
        
        //actions
        
        //get action and execute it
        if(newStep){
        	
           //check Jobs
           if (lookingForJob == false){
        	   if(teamMode == false){
        		   if(getName().equals("agent"+coordinator)){
            		   LogicGoal checkJobs = new LogicGoal("checkJobs");
                 	   addMyGoal(checkJobs);
            	   }
        		   lookingForJob = true;
        	   }
            }
           
           	//for testing:
       		final long timeEnd = System.currentTimeMillis();
       		println("time=" + (timeEnd - timeStart) + " mili s");
       	
       		//check Goals
       		return checkGoals(newStep);
        	
        }
        
        println("skip1");
        return lastAction=CityUtil.action("skip");
    }

    
    //check goals
    public Action checkGoals(boolean newStep){
    	//get goalBase
    	Stack<LogicGoal> logicGoals = getMyGoalBase();
    	
    	//no goals
    	if(logicGoals.isEmpty()){
    		println("No goal available");
    		return lastAction=CityUtil.action("skip");
    	}
    	
    	//checkJobs goal
    	else if(logicGoals.peek().getPredicate().equals("checkJobs")){
    		println("ack=" + acknowledgement + " < " + numberOfShopBeliefs);
    		if(acknowledgement < numberOfShopBeliefs){//number of agents
    			println("waiting for acknowledgement!");
    			println("acknowledgement=" + acknowledgement);
    			return lastAction=CityUtil.action("skip"); 
    		}else{
    			println("checkJobs");
    			//check time left before simulation is over
    	    	if(checkSimTimeLeft == true){
    	    		if(steps - currentStep < timeMin){
    	    			println("sim end:" + steps+ ", current step:" + currentStep);
    	    			println("Not enough time left until simulation is over!");
            			executingJob = false;
            			println("executingJob = false");
            			return lastAction=CityUtil.action("skip");
    	    		}
    	    	}
        		if(pricedJobs.isEmpty()){
        			println("skip4");
        			executingJob = false;
        			println("executingJob = false");
        			return lastAction=CityUtil.action("skip"); 
        		}else{
            	    //check every job in the pricedJob list, stop if a job is taken 
                	for(int i=0; i< pricedJobs.size(); i++){
                		LinkedList<Parameter> job = pricedJobs.get(i);
                		
                		if(rejectedJobs.contains(job.get(0).toString())){
                			println("job was already rejected!");
                			continue;
                		}else{
                			if(checkJob(job, 0)==true){
                             	   LogicGoal executeJob = new LogicGoal("executeJob", job.get(0).toString());
                             	   addMyGoal(executeJob); 
                             	   LogicGoal wait = new LogicGoal("wait");
                             	   addMyGoal(wait); 
                             	   return checkGoals(newStep);
                      		}else{
                      			rejectedJobs.add(job.get(0).toString());
                      		}
                		}
                		
                	}
                	println("skip5");
            		return lastAction=CityUtil.action("skip");  
        		} 
    		}
    		   
    	}
    	
    	//executeJob goal	
    	else if(logicGoals.peek().getPredicate().equals("executeJob")){
    		println("executeJob");
    		myJob = logicGoals.peek().getParameters().get(0);
    		for(LinkedList<Parameter> job: pricedJobs){
    			if(job.get(0).toString().equals(myJob)){
    				currentStorage = job.get(1).toString();
    				currentJobEnd = new Integer (job.get(3).toProlog()).intValue();
    			}
    		}
    		println("currentStorage=" + currentStorage);
    		println("Job End="+currentJobEnd);
    		println("jobPlans.size=" + jobPlans.size());
    		for(LinkedList<Vector<String>> plans: jobPlans){ //for all the plans
    			println(plans.get(0).get(0) + " == " + logicGoals.peek().getParameters().get(0));
    			if(plans.get(0).get(0).equals(logicGoals.peek().getParameters().get(0))){
    				println("plans.size=" + plans.size());
    				if(plans.size()==1){//plans.size()==1 means the agent has no plans for this job
    					//check if job is still available
    					if(executingJob==true){
    						println("wait");
        	            	LogicGoal wait = new LogicGoal("wait");
        	            	addMyGoal(wait);
    					}else{
    						removeMyGoal();
    					}
        				
        	    		println("test2");
            			return checkGoals(newStep);
    				}else{
    					//executingJob = true;
    					println(plans.get(0).get(0) + " == " + logicGoals.peek().getParameters().get(0));
    					if(plans.get(0).get(0).equals(logicGoals.peek().getParameters().get(0))){ //find the plans for the current job
        					int number = plans.size();
        					while(plans.size()>1){ //find the plan with the next plan number -> from last to first so the sequence on the stack is first to last
            					LinkedList<Vector<String>> removePlan = new LinkedList<Vector<String>>(); //for all the plans that have to be removed from plans
            					for(Vector<String> plan: plans){
            						if(plan.get(1).equals(new Integer(number).toString())){
            							LogicGoal action = new LogicGoal(plan.get(3), plan.subList(4, plan.size())); //create goal out of plan
                						addMyGoal(action);
                						println("goal: " + plan.get(3)+ " " + plan.subList(4, plan.size()));
                						removePlan.add(plan);
                						number--;
                					}
            						if(number==1){
            							break;
            						}
                				}
            					for(Vector<String> plan: removePlan){
            						plans.remove(plan);
            					}
            				}
            				return checkGoals(newStep);
            			}
    				}
    			}
    		}
    		return checkGoals(newStep);
    	}
    	
    	//recharge goal	
    	else if(logicGoals.peek().getPredicate().equals("charge")){
    		println("charge" + charge);
    		println("batteryCapacity" + batteryCapacity);
    		if(charge == batteryCapacity){
    			removeMyGoal();
    			recharging = false;
    			if(logicGoals.isEmpty()){
    				println("skip6");
    				return lastAction=CityUtil.action("skip");
    			}else{
    			return checkGoals(newStep);
    			}
    		}else{
    			println("recharge goal");
    			println(getName()+": Executing: Charge");
    			return lastAction=CityUtil.action("charge");
    		}
    	}
    	
    	//breakdown goal
    	else if(logicGoals.peek().getPredicate().equals("breakdown")){
    		if(charge==batteryCapacity){
    			removeMyGoal();
    			return checkGoals(newStep);
    		}else{
    			println("call breakdown service");
    			if(getName().equals("agent" + coordinator)){
 	    			writeInLog(getName()+": had to call breakdown service!");
 	    		}else{
 	    			LogicBelief log = new LogicBelief("log"+getName(), getName()+": had to call breakdown service!");
 	    			sendMessage(log, "agent"+coordinator);
 	    			println("send Message");
 	    		}
    			return lastAction=CityUtil.action("call_breakdown_service");
    		}
    	}
    	
    	//goto goal
    	else if(logicGoals.peek().getPredicate().equals("goto")){
    		println(logicGoals.peek().getParameters().get(0).toString());
    		println("facility="+inFacility);
    		String facilitySubstring = logicGoals.peek().getParameters().get(0).toString().substring(0, 11);
    		println(facilitySubstring + " = " + "facility=sh");
    		if(checkCharge==false){
    			if((facilitySubstring.equals("facility=ch")==false)&&(facilitySubstring.equals("facility=ch")==false)){
        			LinkedList<LinkedList<Parameter>> facilities = new LinkedList<LinkedList<Parameter>>();
    				if(facilitySubstring.equals("facility=sh")){
        				facilities = shops;
        			}else if(facilitySubstring.equals("facility=wo")){
        				facilities = workshops;
        			}else if(facilitySubstring.equals("facility=st")){
        				facilities = storages;
        			}else if(facilitySubstring.equals("facility=du")){
        				facilities = dumps;
        			}
        			if(checkCharge(logicGoals.peek().getParameters().get(0).toString(), facilities)==false){
        				return checkGoals(newStep);
        			}
    			}
    			checkCharge=true;
    		}
    		
        	if (logicGoals.peek().getParameters().get(0).toString().equals("facility="+inFacility)){
        		removeMyGoal();
        		checkCharge = false;
        		if(logicGoals.isEmpty()){
    				println("skip7");
    				return lastAction=CityUtil.action("skip");
    			}else{
    			return checkGoals(newStep);
    			}
        	}else{
        		println("goto goal");
        		println("goto " + myGoals.peek().getParameters().get(0));
        		println(getName()+": Executing: goto");
        		return lastAction=CityUtil.action("goto", myGoals.peek().getParameters().get(0));
        	}
        }
    	
    	//buy goal
    	else if(logicGoals.peek().getPredicate().equals("buy")){
    		println("buy");
    		Vector<String> parameters = logicGoals.peek().getParameters();
    		
    		println("last goal:" + logicGoals.toArray()[logicGoals.toArray().length-2]);
    		if(logicGoals.toArray()[logicGoals.toArray().length-2].toString().substring(0, 1).equals("a")){
    			nextDestination = "workshop";
    		}else if(logicGoals.toArray()[logicGoals.toArray().length-2].toString().substring(0, 1).equals("d")){
    			nextDestination = "storage";
    		}
    		
    		if(parameters.get(2).equals("none")){
    			String newShop = chooseShop(parameters.get(0), parameters.get(3));
    			parameters.set(2, newShop);
    			removeMyGoal();
    			LogicGoal buy = new LogicGoal("buy", parameters);
            	addMyGoal(buy);
            	return checkGoals(newStep);
    			
    		}else if(("facility=" + inFacility).equals(parameters.get(2))){ //agent is already in the right shop
    			println("last action param: " + lastActionParam);
    			println("last action param: " + "item=" + parameters.get(0) + " amount=" + parameters.get(1));
        		if(lastAction.getName().equals("buy") && lastActionParam.equals("item=" + parameters.get(0) + " amount=" + parameters.get(1)) && lastActionResult.equals("successful")){
        			removeMyGoal();
        			return checkGoals(newStep);
        		}
    			for(Vector<String> shopBelief: shopBeliefs){
    				if(("facility=" + shopBelief.get(0)).equals(parameters.get(2))){
    					for(int i=3; i<shopBelief.size(); i++){
    						LinkedList<String> info = getInfo(shopBelief.get(i));
    						//check if there are enough items
    						if(Integer.parseInt(info.get(3)) >= Integer.parseInt(parameters.get(1))){
    							println("buy item");
    							return lastAction=CityUtil.action("buy", "item=" + parameters.get(0) + " amount=" + parameters.get(1));
    						}//if the items will be restocked soon enough
    						else if((Integer.parseInt(parameters.get(1)) - Integer.parseInt(info.get(3))) * Integer.parseInt(info.get(4)) <=10){
    							println("wait for item");
    							return lastAction=CityUtil.action("skip");
    						}else{ //if the agent has to go to another shop
    							println("look for item in another shop");
    							removeMyGoal(); //remove old buy goal
    							LinkedList<LinkedList<Parameter>> shopsWithItem = new LinkedList<LinkedList<Parameter>>(getShopsWithItem(parameters.get(0)));
    							LinkedList<Parameter> oldShop = new LinkedList<Parameter>();
    							for(LinkedList<Parameter> shop: shopsWithItem){
    								println("facility=" + shop.get(0).toString() + " = " + parameters.get(2));
    								if(("facility=" + shop.get(0).toString()).equals(parameters.get(2))){
    									oldShop = shop;
    									shopsWithItem.remove(shop);
    									break;
    								}
    							}
    							if(shopsWithItem.isEmpty()){
    								println("there is no other shop: agent has to wait");
    								return lastAction=CityUtil.action("skip");
    							}
    							String newShop = "";
    							if(costsBeforeTime==false){
    								newShop = getClosestFacilityToFacility(shopsWithItem, oldShop);
    								println("newShop=" + newShop);
    							}else{
    								newShop = getCheapestShop(shopsWithItem, parameters.get(0));
    								println("newShop=" + newShop);
    							}
    							Vector<String> newParameters = new Vector<String>();
								newParameters.add(parameters.get(0));
								newParameters.add(parameters.get(1));
								newParameters.add(newShop);
								for(int j=3;j<parameters.size();j++){
									newParameters.add(parameters.get(j));
								}
								//new buy goal
    							LogicGoal buy = new LogicGoal("buy", newParameters);
    			    			addMyGoal(buy);
    			    			//new goto goal
								LogicGoal gotoShop = new LogicGoal("goto", newParameters.get(2));
    			    			addMyGoal(gotoShop);
    			    			return checkGoals(newStep);
    							
    						}
    					}
    				}
    			}
    		}else{ //agent is not in the right shop and has to go there
    			LogicGoal gotoShop = new LogicGoal("goto", parameters.get(2));
    			addMyGoal(gotoShop);
    			println("add goto goal:" + gotoShop.getParameters());
    			return checkGoals(newStep);
    		}
    		return lastAction=CityUtil.action("skip");
    	}
    	
    	//assemble goal
    	else if(logicGoals.peek().getPredicate().equals("assemble")){
    		println("assemble");
    		Vector<String> parameters = logicGoals.peek().getParameters();
    		//check if lastAction was assemble and was successful
     	    String action = lastAction.getName();
     	    if(action.equals("assemble")){
     	    	if(lastActionResult.equals("successful") && lastActionParam.equals("item=" + parameters.get(0))){   		
     	    		//check last assemble action was related to current goal
     	    		//send message to all assistants
     	    		if(parameters.size()>2){
     	    			for(int i=2; i<parameters.size(); i++){
     	    				Vector<String> beliefParameter = new Vector<String>();
     	    				beliefParameter.add(parameters.get(0));
     	    				beliefParameter.add(parameters.get(1));
     	    				beliefParameter.add(getName());
     	    				LogicBelief assistant_belief = new LogicBelief("assemble_successful"+getName(), beliefParameter);
     	    				println("send message to: " + "agent" + getTeam() + parameters.get(i).substring(1));
     	    				sendMessage(assistant_belief, "agent" + getTeam() + parameters.get(i).substring(1));
     	    			}
     	    		}
     	    		assembling=false;
     	    		removeMyGoal();
     	    		LogicGoal wait = new LogicGoal("wait");
            		addMyGoal(wait);
     	    		return checkGoals(newStep);
     	    	}
     	    	//else react to error message!
     	    }
    		if(("facility=" + inFacility).equals(parameters.get(1))){ //agent is already in the right workshop
    			
    			assembling=true;
				if(parameters.size()>2){
 	    			for(int i=2; i<parameters.size(); i++){
 	    				Vector<String> beliefParameter = new Vector<String>();
 	    				beliefParameter.add(parameters.get(0));
 	    				beliefParameter.add(parameters.get(1));
 	    				beliefParameter.add(getName());
 	    				LogicBelief assistant_belief = new LogicBelief("assist_assemble"+getName(), beliefParameter);
 	    				println("send message to: " + "agent" + getTeam() + parameters.get(i).substring(1));
 	    				sendMessage(assistant_belief, "agent" + getTeam() + parameters.get(i).substring(1));
 	    			}
 	    		}
				return lastAction=CityUtil.action("assemble", "item=" + parameters.get(0));
    			
    		}else{ //agent is not in the right workshop and has to go there
    			LogicGoal gotoWorkshop = new LogicGoal("goto", parameters.get(1));
    			addMyGoal(gotoWorkshop);
    			return checkGoals(newStep);
    		}
    	}
    	
    	//assist_assemble goal
    	else if(logicGoals.peek().getPredicate().equals("assist_assemble")){
    		println("assist_assemble");
    		println("assembling=" + assembling);
    		println("currentAssembler=" + currentAssembler);
    		Vector<String> parameters = logicGoals.peek().getParameters();
    		//check if lastAction was assist_assemble and was successful
     	    String action = lastAction.getName();
     	    if(action.equals("assist_assemble")){
     	    	println("last action was assist_assemble");
     	    	println("result message:"+lastActionResult);
     	    	
     	    	//if assembler is in front of assistant and already sent message
     	    	if(lastActionResult.equals("successful") && lastActionParam.equals("assembler=" + parameters.get(2))){
     	    		if(assembling == false){
     	    			println("assist successful!");
     	    			removeMyGoal();
     	    			LogicGoal wait = new LogicGoal("wait");
                		addMyGoal(wait);
            			return checkGoals(newStep);
     	    		}else{
     	    			return lastAction=CityUtil.action("assist_assemble", "assembler=" + parameters.get(2));
     	    		}
     	    	}
     	    	//else react to error message!
     	    	//failed_counterpart: if assistant is in front of assembler and assembler sent message last step and has already moved on
     	    	else if(lastActionResult.equals("failed_counterpat") || lastActionResult.equals("failed_random")){
 	    			if(assembling == false){
     	    			println("assist successful!");
 	    				removeMyGoal();
     	    			LogicGoal wait = new LogicGoal("wait");
                		addMyGoal(wait);
            			return checkGoals(newStep);
 	    			}else{
 	     	    		println("try again");
 	     	    		return lastAction;
 	    			}
     	    	}
     	    	
     	    	
     	    }
    		if(("facility=" +inFacility).equals(parameters.get(1))){ //agent is already in the right workshop
    			currentAssembler = parameters.get(2);
    			println("currentAssembler=" + currentAssembler);
    			if(assembling==true){
	    			println("assembling=" + assembling);
	    			return lastAction=CityUtil.action("assist_assemble", "assembler=" + parameters.get(2));
	    		}else{
		    		println("waiting for assembler");
	    			return lastAction=CityUtil.action("skip");
	    		}
    		}else{ //agent is not in the right workshop and has to go there
    			currentAssembler = parameters.get(2);
    			println("currentAssembler=" + currentAssembler);
    			LogicGoal gotoWorkshop = new LogicGoal("goto", parameters.get(1));
    			addMyGoal(gotoWorkshop);
    			return checkGoals(newStep);
    		}
    	}
    	
    	//receive goal
    	else if(logicGoals.peek().getPredicate().equals("receive")){
    		println("receive");
    		//check if agent got a new item
    		Vector<String> parameters = logicGoals.peek().getParameters();
    		for(LinkedList<Parameter> item: items){
    			for(LinkedList<Parameter> oldItem: oldItems){
        			if(item.get(0).equals(oldItem.get(0))){
        				if(item.get(0).toString().equals(parameters.get(0))){
 	        				//if(amount of item == old amount of item + amount of assembled item)
 	        				if(new Integer(item.get(1).toProlog()).intValue() == new Integer(oldItem.get(1).toProlog()).intValue() + Integer.parseInt(parameters.get(1))){
 	        	 	    		removeMyGoal();
 	        	 	    		return checkGoals(newStep);
 	        				}else{
 	        	 	    		return lastAction=CityUtil.action("receive");
 	        				}
	        			}
        			}
    			}
    		}
    		return lastAction=CityUtil.action("skip");
    	}
    	
    	//give goal
    	else if(logicGoals.peek().getPredicate().equals("give")){
    		println("give");
    		 //check if lastAction was successful 
     	    String action = lastAction.getName();
     	    //check if action failed because the other agent was not there, try again
     	    if(action.equals("give")){
     	    	if(lastActionResult.equals("failed_counterpat")||lastActionResult.equals("failed_location")){
     	    		return lastAction;
     	    	}
     	    }
    		//check if agent has given away the item
    		Vector<String> parameters = logicGoals.peek().getParameters();
    		for(LinkedList<Parameter> item: items){
    			for(LinkedList<Parameter> oldItem: oldItems){
        			if(item.get(0).equals(oldItem.get(0))){
        				if(item.get(0).toString().equals(parameters.get(0))){
 	        				//if(amount of item == old amount of item + amount of assembled item)
 	        				if(new Integer(item.get(1).toProlog()).intValue() == new Integer(oldItem.get(1).toProlog()).intValue() - Integer.parseInt(parameters.get(1))){
 	        	 	    		removeMyGoal();
 	        	 	    		return checkGoals(newStep);
 	        				}else{
 	        	 	    		return lastAction=CityUtil.action("receive");
 	        				}
	        			}
        			}
    			}
    		}
     	   return lastAction=CityUtil.action("skip");
    	}
    	
    	//store goal
    	else if(logicGoals.peek().getPredicate().equals("store")){
    		println("store");
    		Vector<String> parameters = logicGoals.peek().getParameters();
    		//check if lastAction was store and was successful
     	    String action = lastAction.getName();
     	    if(action.equals("store")){
     	    	println("last action was store");
     	    	if(lastActionResult.equals("successful") && lastActionParam.equals("item=" + parameters.get(1)+ " amount=" + parameters.get(2))){
     	    		println("store successful!");
     	    		removeMyGoal();
     	    		//LogicGoal wait = new LogicGoal("wait");
                	//addMyGoal(wait);
            		return checkGoals(newStep);
     	    	}
     	    	//else react to error message!
     	    	else if(lastActionResult.equals("failed_capacity")){
     	    		if(getName().equals("agent" + coordinator)){
     	    			writeInLog(getName()+": Failed Capacity!");
     	    		}else{
     	    			LogicBelief log = new LogicBelief("log"+getName(), getName()+": Failed Capacity!");
     	    			sendMessage(log, "agent"+coordinator);
     	    			println("send Message");
     	    		}
     	    		//do something
     	    		return lastAction=CityUtil.action("skip");
     	    	}
     	    }
    		if(("facility=" +inFacility).equals("facility=" + parameters.get(0))){ //agent is already in the right storage
    			return lastAction=CityUtil.action("store", "item=" + parameters.get(1) + " amount=" + parameters.get(2));
    		}else{ //agent is not in the right storage and has to go there
    			LogicGoal gotoStorage = new LogicGoal("goto", "facility=" + parameters.get(0));
    			addMyGoal(gotoStorage);
    			return checkGoals(newStep);
    		}
    	}
    	
    	//retrieve goal
    	else if(logicGoals.peek().getPredicate().equals("retrieve")){
    		println("retrieve");
    		Vector<String> parameters = logicGoals.peek().getParameters();
    		//check if lastAction was retrieve and was successful
     	    String action = lastAction.getName();
     	    if(action.equals("retrieve")){
     	    	println("last action was retrieve");
     	    	if(lastActionResult.equals("successful") && lastActionParam.equals("item=" + parameters.get(1)+ " amount=" + parameters.get(2))){
     	    		println("retrieve successful!");
     	    		removeMyGoal();
     	    		//LogicGoal wait = new LogicGoal("wait");
                	//addMyGoal(wait);
            		return checkGoals(newStep);
     	    	}
     	    }
    		if(("facility=" +inFacility).equals("facility=" + parameters.get(0))){ //agent is already in the right storage
    			return lastAction=CityUtil.action("retrieve", "item=" + parameters.get(1) + " amount=" + parameters.get(2));
    		}else{ //agent is not in the right storage and has to go there
    			LogicGoal gotoStorage = new LogicGoal("goto", "facility=" + parameters.get(0));
    			addMyGoal(gotoStorage);
    			return checkGoals(newStep);
    		}
    	}
    	
    	//deliver_job goal
    	else if(logicGoals.peek().getPredicate().equals("deliver_job")){
    		println("deliver_job");
    		//check if lastAction was successful 
     	    String action = lastAction.getName();
     	    if(action.equals("deliver_job")){
     	    	/*if(lastActionResult.equals("successful")){
     	    		//LogicBelief log = new LogicBelief("log"+getName(), logicGoals.peek().getParameters().get(0)+" was successfully delivered in step"+currentStep+"!");
     	    		//sendMessage(log, "agent"+coordinator);
     	    		//println("send Message");
     	    		println("deliver Job goal successfull branch");
     	    	}*/
     	    	if(lastActionResult.equals("successful")||lastActionResult.equals("successful_partial")){
     	    		removeMyGoal();
     	    		itemsStored=false;
     	    		return checkGoals(newStep);
     	    	}
     	    }
    		Vector<String> parameters = logicGoals.peek().getParameters();
    		if(inFacility.equals(parameters.get(1))){ //agent is already in the right storage
    			if(itemsStored == false){
    				LogicGoal tmpGoal = getMyGoalBase().peek();
            		println("current goal = " + tmpGoal);
            		removeMyGoal();
    				LinkedList<LinkedList<Parameter>> storeItems = checkItems(parameters.get(0), parameters.get(2));
        			for(LinkedList<Parameter> item: storeItems){
        				Vector<String> storeParameters = new Vector<String>();
        				storeParameters.add(parameters.get(1));
        				storeParameters.add(item.get(0).toString());
        				storeParameters.add(item.get(1).toString());
        				LogicGoal retrieveItem = new LogicGoal("retrieve", storeParameters);
        				addMyGoal(retrieveItem);
        			}
        			addMyGoal(tmpGoal);
        			for(LinkedList<Parameter> item: storeItems){
        				Vector<String> storeParameters = new Vector<String>();
        				storeParameters.add(parameters.get(1));
        				storeParameters.add(item.get(0).toString());
        				storeParameters.add(item.get(1).toString());
        				LogicGoal storeItem = new LogicGoal("store", storeParameters);
        				addMyGoal(storeItem);
        			}
        			itemsStored=true;
        			return checkGoals(newStep);
    			}else{
        			return lastAction=CityUtil.action("deliver_job", "job=" + parameters.get(0));
    			}
    		}else{ //agent is not in the right storage and has to go there
    			LogicGoal gotoStorage = new LogicGoal("goto", "facility=" + parameters.get(1));
    			addMyGoal(gotoStorage);
    			return checkGoals(newStep);
    		}
    	}
    	
    	//wait goal: agent waits for one step
    	else if(logicGoals.peek().getPredicate().equals("wait")){
    		removeMyGoal();
        	println("wait");
        	return lastAction=CityUtil.action("skip");
    	}
    	
    	//unknown goal
    	else{
        	println("Unknown goal!");
        	return lastAction=CityUtil.action("skip");
        }
                       	
    } 
    
    //check if job conditions are acceptable
    public boolean checkJob (LinkedList<Parameter> job, int team){
    	
    	println("job:" + job);
    	
    	ParameterList jobProducts = (ParameterList) job.get(5); //list of products needed to deliver job 
    	
    	if(checkJobConditions == true){
    	
    	//check if there is an item with depth > maxItemDepth
    		for(Parameter product: jobProducts){
    			if(itemDepth.get(getInfo(product.toString()).get(1))>maxItemDepth){
    				println("Do not take job! Item too deep!");
    				return false;
    			}
    		}
    		
    		println("checkJobTimeLeft=" + checkJobTimeLeft);
        	//check time left before job is cancelled
        	if(checkJobTimeLeft == true){
        		if((new Integer (job.get(3).toProlog()).intValue()) - currentStep < timeMin){
        			println("job end:" + (new Integer (job.get(3).toProlog()).intValue())+ ", current step:" + currentStep);
        			println("Not enough time left until job gets cancelled!");
        			return false;
        		}
        	}
    	
    	}
    	
    	//check if reward >= money needed to deliver job
    	int reward = new Integer (job.get(4).toProlog()).intValue();
    	int cost = 0; //total cost of all the items needed for the job
    	int lowestCost = 0;
    	String cheapestShop = "shop1";
    	int costForBuyAssembledItems = 0;
    	
    	//get storage and workshop
    	String workshopForJob = "";
    	println("workshopForJob=" + workshopForJob);
		LinkedList<Parameter> storageForJob = new LinkedList<Parameter>();
    	for(LinkedList<Parameter> storage: storages){
    		if(storage.get(0).toString().equals(job.get(1).toString())){
    			storageForJob = storage;
    			println("storage=" + storageForJob);
    			break;
    		}
    	}
    	if(costsBeforeTime == false){
    		workshopForJob = getClosestFacilityToFacilityGraphHopper(workshops, storageForJob);
    	}else{
    		workshopForJob = cheapestWorkshop.get(0).toString();
    	}
    	println("workshopForJob=" + workshopForJob);
    	

		//costs for random simulation
    	println("jobConditions= " + checkJobConditions);
    	if(checkJobConditions == true){
        	for(Parameter jobProduct: jobProducts){
        		LinkedList<String> jobProductInfo = getInfo(jobProduct.toString());
        		//cost = cost + amount of product * cost of product in cheapest shop
        		cost = cost + Integer.parseInt(jobProductInfo.get(2)) * getCostOfProductWithWorkshop(jobProductInfo.get(1).toString(), workshopForJob);
        		}
        	println("cost = " + cost);
        	println("reward = " + reward);
        	if(cost == 0){
        		println("Error: could not calculate cost!");
        		writeInLog("CheckJob Error: could not calculate cost!");
        		return false;
        	}else if(cost + jobSafetyFactor > reward){
        		println("Do not take job! Reward too small!");
        		return false;
        	}
        	println("Take job!");
    	}
    	
    	if(buyAssembledItems==false){
        	buyAssembledItems = true;
        	for(Parameter jobProduct: jobProducts){
        		LinkedList<String> jobProductInfo = getInfo(jobProduct.toString());
        		//cost = cost + amount of product * cost of product in cheapest shop
        		costForBuyAssembledItems = costForBuyAssembledItems + Integer.parseInt(jobProductInfo.get(2)) * getCostOfProductWithWorkshop(jobProductInfo.get(1).toString(), workshopForJob);
        		}
        	println("cost = " + cost);
        	buyAssembledItems = false;
    	}else{
    		buyAssembledItems = false;
        	for(Parameter jobProduct: jobProducts){
        		LinkedList<String> jobProductInfo = getInfo(jobProduct.toString());
        		//cost = cost + amount of product * cost of product in cheapest shop
        		costForBuyAssembledItems = costForBuyAssembledItems + Integer.parseInt(jobProductInfo.get(2)) * getCostOfProductWithWorkshop(jobProductInfo.get(1).toString(), workshopForJob);
        		}
        	println("cost = " + cost);
        	buyAssembledItems = true;
    	}
    	
    	//develop strategy for job
    	
    	LinkedList<LinkedList<String>> myAgents = new LinkedList<LinkedList<String>>();
    	
    	
    	if(teamMode == false){
    		
    		myAgents = getListOfAgents();
        	
        	myAgents = sortAgentsByRole(myAgents);
        	
        	for(LinkedList<String> myAgent: myAgents){
        		for(Vector<String> myItem: allMyItems){
        			//println("agent" + getTeam() + myAgent.get(0).substring(1) + " == " + myItem.get(0));
        			if(("agent" + getTeam() + myAgent.get(0).substring(1)).equals(myItem.get(0))){
        				println("myItem:" + myItem);
        				for(int i=1; i<myItem.size(); i=i+2){
        					println(myItem.get(i) + " " + myItem.get(i+1));
        					for(int j= Integer.parseInt(myItem.get(i+1)); j>0; j--){
        						println("j=" + j);
        						myAgent.add(myItem.get(i));
        						println("add " + myItem.get(i));
        					}
        				}
        			}
        		}
        		myAgent.set(numberOfTools+7, new Integer(getVolumeOfLoad(getSublist(myAgent, numberOfTools+8, myAgent.size()))).toString());
        		
        	}
        	
        	println("My agents:");
       	   	for(LinkedList<String> myAgent: myAgents){
       		   println(myAgent);
       	   	}
    		
    	}else{
		   	
		   	LinkedList<LinkedList<LinkedList<String>>> jobAgentTeams = getAgentTeams(allMyAgents);
		   	
		   	myAgents = jobAgentTeams.get(team);	
		   	
		   	println("all my items:");
		   	for(Vector<String> myItem:allMyItems){
		   		println(myItem.toString());
		   	}
		   	
		   	for(LinkedList<String> myAgent: myAgents){
        		for(Vector<String> myItem: allMyItems){
        			//println("agent" + getTeam() + myAgent.get(0).substring(1) + " == " + myItem.get(0));
        			if(("agent" + getTeam() + myAgent.get(0).substring(1)).equals(myItem.get(0))){
        				for(int i=1; i<myItem.size(); i=i+2){
        					for(int j= Integer.parseInt(myItem.get(i+1)); j>0; j--){
        						myAgent.add(myItem.get(i));
        					}
        				}
        			}
        		}
        		myAgent.set(numberOfTools+7, new Integer(getVolumeOfLoad(getSublist(myAgent, numberOfTools+8, myAgent.size()))).toString());
        		
        	}
        	
        	println("My agents:");
       	   	for(LinkedList<String> myAgent: myAgents){
       		   println(myAgent);
       	   	}
       	   	
       	   	println("allMyAgents:");
       	   	for(LinkedList<String> myAgent: allMyAgents){
     		   println(myAgent);
     	   	}
       	   	
    	}
    	
    	int cooperation = 0;
    	
    	if(getTeam().equals("A")){
    		cooperation = cooperationA;
    	}else{
    		cooperation = cooperationB;
    	}
    	println("cooperation= " + cooperation);
    	
    	int volume=0;
    	if(cooperation==0 || cooperation==1){
    		//check which tools are needed to build a material
    		LinkedList<String> allTools = new LinkedList<String>();
    		for(Parameter jobProduct: jobProducts){
    			LinkedList<String> jobProductInfo = getInfo(jobProduct.toString());
    			LinkedList<String> jobProductTools = getTools(jobProductInfo.get(1));
    			for(String jobProductTool: jobProductTools){
    				allTools.add(jobProductTool);
    			}
    		}
    		
    		//check if there is an agent that can use all of those tools
    		LinkedList<LinkedList<String>> capableAgents = new LinkedList<LinkedList<String>>();
    		for(LinkedList<String> myAgent: myAgents){
    			boolean capability = false;
    			for(String tool: allTools){
    				for(int i=7; i<myAgent.size()-1;i++){				
    					if(myAgent.get(i).equals(tool)){
    						capability = true;
    						break;
    					}else{
    						capability = false;
    					}
    				}
    				if(capability == false){
    					break;
    				}
    			}
    			if(capability == true){
    				capableAgents.add(myAgent);
    			}
    		}
    		
    		if(capableAgents.isEmpty()){ //job is not executable with cooperation=0
    			println("Job is not executable with cooperation level 0!");
    			if(cooperation == 0){
    				println("return false");
    			}
    		}else{ //job might be executable with cooperation=0; continue searching for strategy

        		//check if all items for the job can be carried by one agent
            	for(Parameter jobProduct: jobProducts){
            		LinkedList<String> jobProductInfo = getInfo(jobProduct.toString());
            	  //volume = volume + amount of product * volume of components
            		volume = volume + Integer.parseInt(jobProductInfo.get(2)) * getVolumeOfComponents(jobProductInfo.get(1));
            	}
            	for(LinkedList<String> capableAgent: capableAgents){
            		
            	}
    		}
    		
    	}
    	if(cooperation==1 || cooperation==2){
    		//for testing
    		for(Parameter jobProduct: jobProducts){
        		LinkedList<String> jobProductInfo = getInfo(jobProduct.toString());
        	  //volume = volume + amount of product * volume of components
        		volume = volume + Integer.parseInt(jobProductInfo.get(2)) * getVolumeOfComponents(jobProductInfo.get(1));
        	}
        	int teamCapacity = 0;
        	for(LinkedList<String> myAgent: myAgents){
        		if(myAgent.size()>5){
            		teamCapacity = teamCapacity + Integer.parseInt(myAgent.get(5));
        		}
        	}
        	if(teamCapacity<=volume){
        		println("Multiple trips needed!");
        	}else{
        		println("All in one go!");
        	}
        	
        	boolean productsEmpty = false;
        	
        	LinkedList<LinkedList<Vector<String>>> agentPlans = new LinkedList<LinkedList<Vector<String>>>();
        	for(LinkedList<String> myAgent: myAgents){
        		Vector<String> plan = new Vector<String>();
        		plan.add(myAgent.get(0));
        		LinkedList<Vector<String>> plans = new LinkedList<Vector<String>>();
        		plans.add(plan);
        		agentPlans.add(plans);
        	}
        	
        	
        	//distribute item
        	
        	LinkedList<LinkedList<String>> jobProductList = new LinkedList<LinkedList<String>>();
        	for(Parameter jobProduct: (ParameterList) jobProducts){
        		LinkedList<String> jobProductInfo = getInfo(jobProduct.toString());
        		jobProductList.add(jobProductInfo);
        	}
        	
        	int currentAgent = 0;
        	int currentTrip = 0;
        	String assembler = "none";
        	String currentMaterial = "none";
        	String jobID = job.get(0).toString();
        	String storage = job.get(1).toString();
        	
        	//create plan0 for all agents
        	for(LinkedList<String> myAgent:myAgents){
        		Vector<String> plan = new Vector<String>();
				plan.add(myAgent.get(0));
				plan.add("no action");
				plan.add("no parameters");
				plan.add("no parameters");
				plan.add("no parameters");
				createPlan(agentPlans, plan);
        	}
        	
        	
        	if(divideItems(jobProductList, myAgents, agentPlans, currentAgent, currentTrip, workshopForJob, assembler, currentMaterial, jobID, storageForJob.get(0).toString()) == false){
        		println("Job cannot be completed!");
        		return false;
        	}
        	
        	//send plans to corresponding agent
        	for(LinkedList<Vector<String>> plans: agentPlans){
        		int planNumber = 0;
        		for(Vector<String> plan: plans){
        			Vector<String> parameters = new Vector<String>();
        			parameters.add(job.get(0).toString());
        			parameters.add(new Integer(planNumber).toString());
        			for(int i=0; i<plan.size();i++){
        				parameters.add(plan.get(i));
        			}
        			
        			if(planNumber != 0){
                    	LogicBelief belief = new LogicBelief("plan" + planNumber, parameters);
                    	if(getName().equals("agent" + getTeam() + plans.get(0).get(0).substring(1))){
                        	addBelief(belief);
                        	println("belief add " + getName() + " " + parameters.get(3) + " " + parameters.get(4));
                        	if(parameters.get(3).equals("assemble")||parameters.get(3).equals("assist_assemble")){
                    			println("parameters: " + parameters.subList(4, parameters.size()));
                    		} else if(parameters.get(3).equals("buy")){
                    			println("amount=" + parameters.get(5));
                    		}
                    	}else{
                    		sendMessage(belief, "agent" + getTeam() + plans.get(0).get(0).substring(1));
                    		println("belief send " + "agent" + getTeam() + plans.get(0).get(0).substring(1) + " " + parameters.get(3) + " " + parameters.get(4));
                    		if(parameters.get(3).equals("assemble")||parameters.get(3).equals("assist_assemble")){
                    			println("parameters: " + parameters.subList(4, parameters.size()));
                    		}else if(parameters.get(3).equals("buy")){
                    			println("amount=" + parameters.get(5));
                    		}
                    	}
        			}
                	planNumber++;
        		}
        	}
        	
        	allMyItems.clear();
        	
        	writeInLog("job info:","job id = " + job.get(0),"reward = " + job.get(4),"required = " + job.get(5),"estimated costs = " + cost,"estimated cost for buyAssembledItems = " + costForBuyAssembledItems,"money = " + money);
        	println("job info:");
        	println("job id = " + job.get(0));
        	println("reward = " + job.get(4));
        	println("required = " + job.get(5));
        	if(buyAssembledItems==true){
        		println("estimated cost for buyAssembledItems = " + cost);
            	println("estimated costs = " + costForBuyAssembledItems);
        	}else{
        		println("estimated costs = " + cost);
            	println("estimated cost for buyAssembledItems = " + costForBuyAssembledItems);
        	}
        	println("money = " + money);
        	println("step =" + currentStep);
        	
    	}
    	
    	return true;
    }
    		
    
    
    //check which facility is closest
    public String getClosestFacility(LinkedList<LinkedList<Parameter>> facilities){
    
    	println("getClosestFacility");
    	LinkedList<Parameter> closestFacility = facilities.get(0);   	
    	println(closestFacility.get(0));
    	
    	//compare distance to closestFacility with distance to next facility from the list
    	for (int i=1; i<facilities.size(); i++){
        	double latitude2 = new Double (closestFacility.get(1).toProlog());
        	double longitude2 = new Double (closestFacility.get(2).toProlog());
            double latitude3 = new Double (facilities.get(i).get(1).toProlog());
        	double longitude3 = new Double (facilities.get(i).get(2).toProlog());
    		double distance1 = 0;
    		double distance2 = 0;
    		
    		//distance = square root ((lat1-lat2)^2 + (lon1 - lon2)^2)
    		distance1 = java.lang.Math.sqrt(java.lang.Math.pow((latitude - latitude2), 2) + java.lang.Math.pow((longitude - longitude2),2));
    		distance2 = java.lang.Math.sqrt(java.lang.Math.pow((latitude - latitude3), 2) + java.lang.Math.pow((longitude - longitude3),2));
    		
    		if(distance2 < distance1){
    			println("without clear");
    			closestFacility = facilities.get(i);
    		}
    	}
    	println("facility=" + closestFacility.get(0).toString());
    	return "facility=" + closestFacility.get(0).toString();
    }
    
    
    //check which facility is closest to another facility
    public String getClosestFacilityToFacility(LinkedList<LinkedList<Parameter>> facilities, LinkedList<Parameter> facility){
    
    	println("getClosestFacilityToFacility");
    	LinkedList<Parameter> closestFacility = facilities.get(0);   	
    	println(closestFacility.get(0));
    	double latitudeFacility = new Double(facility.get(1).toProlog());
    	double longitudeFacility = new Double(facility.get(2).toProlog());
    	
    	//compare distance to closestFacility with distance to next facility from the list
    	for (int i=1; i<facilities.size(); i++){
        	double latitude2 = new Double (closestFacility.get(1).toProlog());
        	double longitude2 = new Double (closestFacility.get(2).toProlog());
            double latitude3 = new Double (facilities.get(i).get(1).toProlog());
        	double longitude3 = new Double (facilities.get(i).get(2).toProlog());
    		double distance1 = 0;
    		double distance2 = 0;
    		
    		//distance = square root ((lat1-lat2)^2 + (lon1 - lon2)^2)
    		distance1 = java.lang.Math.sqrt(java.lang.Math.pow((latitudeFacility - latitude2), 2) + java.lang.Math.pow((longitudeFacility - longitude2),2));
    		distance2 = java.lang.Math.sqrt(java.lang.Math.pow((latitudeFacility - latitude3), 2) + java.lang.Math.pow((longitudeFacility - longitude3),2));
    		
    		if(distance2 < distance1){
    			println("without clear");
    			closestFacility = facilities.get(i);
    		}
    	}
    	println("facility=" + closestFacility.get(0).toString());
    	return "facility=" + closestFacility.get(0).toString();
    }    
    
    
    //parameterList
    
    //get the ith parameter of a ParameterList
    public Parameter getParam(ParameterList list, int i){
    	int j=0;
    	for(Parameter l: list){
    		if(j==i){
    			return l;
    		}else{
    			j++;
    		}
    	}
    	println("This is actually an IndexOutOfBoundsException!");
    	return null;
    }
    
    //get the size of a ParameterList
    public int sizeParam(ParameterList list){
    	int j=0;
    	for(Parameter l:list){
    		j++;
    	}
    	return j;
    }
    
    //get sublist of a LinkedList<String>
    public LinkedList<String> getSublist(LinkedList<String> myList, int startIndex, int endIndex){
    	LinkedList<String> subList = new LinkedList<String>();
    	for(int i=startIndex; i<endIndex; i++){
    		subList.add(myList.get(i));
    	}
    	return subList;
    }
    
    //get the components of a Parameter (identifier) as a list of strings
    public LinkedList<String> getInfo(String param){
    	LinkedList<String> list = new LinkedList<String>();
    	int idxBracket = param.indexOf("(");
    	list.add(param.substring(0, idxBracket));
    	param = param.substring(idxBracket+1);
    	int idxComma = param.indexOf(",");
    	while(idxComma != -1){
    		list.add(param.substring(0, idxComma));
    		param = param.substring(idxComma+1);
    		idxComma = param.indexOf(",");
    	}
    	idxBracket = param.indexOf(")");
    	list.add(param.substring(0, idxBracket));
    	return list;
    }
    
    //get cost of item; can only be used if near to shop
	public int getCost(String item){
		int cost = 0;
		for(LinkedList<Parameter> shop: shops){
			if(shop.get(0).toString().equals(inFacility)){
				ParameterList availableItems = (ParameterList) shop.get(3);
				for(Parameter availableItem: availableItems){
					LinkedList<String> availableItemInfo = getInfo(availableItem.toString());
					if(availableItemInfo.get(1).equals(item)){
						return cost = Integer.parseInt(availableItemInfo.get(2));
					}
				}
			}
		}
		println("Item not available!");
		return cost;
	}
    
    //get cost of item
    public int getCost(String item, String shop){
    	int cost = 0; 
    	println("item=" + item + " shop=" + shop);
    	for(Vector<String> shopBelief: shopBeliefs){
    		if(("facility=" + shopBelief.get(0)).equals(shop)){
    			for(int i=3; i<shopBelief.size();i++){
    				LinkedList<String> availableItem = getInfo(shopBelief.get(i));
    				if(availableItem.get(1).equals(item)){
    					return cost = Integer.parseInt(availableItem.get(2));
    				}
    			}
    		}
    	}
    	println("Item not available!");
    	return cost;
    }
    
    //get items needed to build product
    public LinkedList<LinkedList<String>> getComponents(String item){
    	LinkedList<LinkedList<String>> components = new LinkedList<LinkedList<String>>();
    	for(LinkedList<Parameter> product: products){
    		if(product.get(0).toString().equals(item)){
    			
    			if(product.get(2).equals(null)){
    				return components;
    			}else{
    				ParameterList productComponents = (ParameterList) product.get(2);
    				for(Parameter component: productComponents){
    					LinkedList<String> componentInfo = getInfo(component.toString());
    					components.add(componentInfo);
    				}
    			}
    		}
    	}
    	return components;
    }
    
    //get volume of item
    public int getVolume(String item){
    	println("getVolume:"+item);
    	int volume = 0;
    	for(LinkedList<Parameter> product: products){
    		if(product.get(0).toString().equals(item)){
    			return volume = new Integer (product.get(1).toProlog()).intValue();
    		}
    	}
    	println("There is no such item!");
    	/*if(getName().equals("agent" + coordinator)){
			writeInLog(getName()+": There is no such item!");
		}else{
			LogicBelief log = new LogicBelief("log"+getName(), getName()+": There is no such Item!");
			sendMessage(log, "agent"+coordinator);
			println("send Message");
		}*/
    	return volume;
    }
    
    //get volume of components
    public int getVolumeOfComponents(String myProduct){
    	int volume = 0;
    	if(getComponents(myProduct).isEmpty()){ //if product cannot be build and has to be bought
    		volume = getVolume(myProduct);
    		return volume;
    	}else{ //if product has to be build
    		LinkedList<LinkedList<String>> components = getComponents(myProduct);
    		for(LinkedList<String> component: components){
    		  //cost = cost + amount of component * cost of components
    			volume = volume + Integer.parseInt(component.get(2)) * getVolumeOfComponents(component.get(1));
    		}
    		if(volume==0){
    			println("Error!");
    			if(getName().equals("agent" + coordinator)){
 	    			writeInLog(getName()+": Volume==0!");
 	    		}else{
 	    			LogicBelief log = new LogicBelief("log"+getName(), getName()+": Volume==0!");
 	    			sendMessage(log, "agent"+coordinator);
 	    			println("send Message");
 	    		}
    		}
    		return volume;
    	}
    }
    
    public int getVolumeOfLoad(LinkedList<String> myItems){
    	println("getVolumeOfLoad");
    	int volume = 0;
    	for(String myItem: myItems){
    		volume = volume + getVolume(myItem);
    		println("volume=" + volume);
    	}
    	return volume;
    }
    
    //get tools needed to build product
    public LinkedList<String> getTools(String myProduct){
    	LinkedList<String> tools = new LinkedList<String>();
    	if(getComponents(myProduct).isEmpty()){//if product cannot be build
   		    if(myProduct.substring(0, 4).equals("tool")){
    			tools.add(myProduct);
    		}
    		return tools;
    	}else{ //if product can be build
    		if(myProduct.substring(0, 4).equals("tool")){
    			tools.add(myProduct);
    		}
    		LinkedList<LinkedList<String>> components = getComponents(myProduct);
    		for(LinkedList<String> component: components){
    			LinkedList<String> componentTools = new LinkedList<String>();
    			componentTools = getTools(component.get(1));
    			for(String tool: componentTools){
    				tools.add(tool);
    			}
    		}
    	}

    	return tools;
    }
    
    //get cost of product, knowing which shop is going to be used (only works, when every item is available in every shop)
    public int getCostOfProduct(String myProduct, String shop){
    	int cost = 0;
    	
    	//get most expensive workshop
    	int workshopPrice = 0;
    	for(LinkedList<Parameter> workshop: workshops){
    		if(new Integer(workshop.get(3).toProlog()).intValue() >= workshopPrice){
    			workshopPrice = new Integer(workshop.get(3).toProlog()).intValue();
    		}
    	}
    	
    	if(getComponents(myProduct).isEmpty()){ //if product cannot be build and has to be bought
    		cost = getCost(myProduct, shop);
    		return cost;
    	}else{ //if product has to be build
    		cost = cost + workshopPrice;
    		LinkedList<LinkedList<String>> components = getComponents(myProduct);
    		for(LinkedList<String> component: components){
    		  //cost = cost + amount of component * cost of component
    			cost = cost + Integer.parseInt(component.get(2)) * getCostOfProduct(component.get(1), shop);
    		}
    		if(cost==0){
    			println("Error!");
    			if(getName().equals("agent" + coordinator)){
 	    			writeInLog(getName()+": cost==0!");
 	    		}else{
 	    			LogicBelief log = new LogicBelief("log"+getName(), getName()+": cost==0!");
 	    			sendMessage(log, "agent"+coordinator);
 	    			println("send Message");
 	    		}
    		}
    		return cost;
    	}
    }
    
  //get cost of product knowing which workshop is going to be used
    public int getCostOfProductWithWorkshop(String myProduct, String workshop){
    	int cost = 0;
    	//there are no costs for using a workshop at the moment
    	//int workshopPrice = 0;
    	LinkedList<Parameter> workshopPercept = new LinkedList<Parameter>();
    	for(LinkedList<Parameter> myWorkshop: workshops){
    		if(("facility=" + myWorkshop.get(0).toString()).equals(workshop)){
    			//workshopPrice = Integer.parseInt(myWorkshop.get(3).toString());
    			workshopPercept = myWorkshop;
    			break;
    		}
    	}
    	
    	println("product:" + myProduct);
    	
    	if(getComponents(myProduct).isEmpty() || buyAssembledItems == true){ //if product cannot be build and has to be bought or buyAssembledItems==true
        	
    		String shop = "";
    		LinkedList<LinkedList<Parameter>> shopsWithItem = getShopsWithItem(myProduct);
    		println(shopsWithItem.get(0).get(0).toString());
        	if(costsBeforeTime == false){
        		shop = getClosestFacilityToFacilityGraphHopper(shopsWithItem, workshopPercept);
        	}else{
        		shop = getCheapestShop(shopsWithItem, myProduct);
        	}
        	println("shop=" + shop);
        	
    		cost = getCost(myProduct, shop);
    		println("cost=" + cost);
    		return cost;
    	}else{ //if product has to be build
    		//cost = cost + workshopPrice;
    		LinkedList<LinkedList<String>> components = getComponents(myProduct);
    		for(LinkedList<String> component: components){
    		  //cost = cost + amount of component * cost of component
    			cost = cost + Integer.parseInt(component.get(2)) * getCostOfProductWithWorkshop(component.get(1), workshop);
    			
    		}
    		println("cost=" + cost);
    		if(cost==0){
    			println("Error!");
    			if(getName().equals("agent" + coordinator)){
 	    			writeInLog(getName()+": cost==0!");
 	    		}else{
 	    			LogicBelief log = new LogicBelief("log"+getName(), getName()+": cost==0!");
 	    			sendMessage(log, "agent"+coordinator);
 	    			println("send Message");
 	    		}
    		}
    		return cost;
    	}
    }
    
    
    public boolean divideItems(LinkedList<LinkedList<String>> items, LinkedList<LinkedList<String>> myAgents, LinkedList<LinkedList<Vector<String>>> agentPlans, int currentAgent, int currentTrip, String workshopForJob, String assembler, String currentMaterial, String jobID, String storage){
		
    	println("new recursion with material:" + currentMaterial + " and assembler:" + assembler);
		println("0currentAgent="+myAgents.get(currentAgent));
		int assemblerAgent = currentAgent;
    	int counter = 0;
		LinkedList<String> participatingAgents = new LinkedList<String>(); //all agents that help assemble currentMaterial
		participatingAgents.add(assembler);
		boolean participating = false;
		LinkedList<String> currentItems = new LinkedList<String>(); //items an agent has at the end of one loop
		LinkedList<LinkedList<String>> itemsForAssembling = new LinkedList<LinkedList<String>>(); //all items that are bought to assemble currentMaterial
		if(assembler.equals("none")==false){
			LinkedList<String> assemblerItems = new LinkedList<String>(); //List for all the items the assembler uses fo assembling
			assemblerItems.add(assembler);
			itemsForAssembling.add(assemblerItems);
		}
		
		//ITEM LOOP
		for(LinkedList<String> itemInfo: items){ //for all items that are needed for the job
    		
			int currentItem = 0;
			
			//BASE ITEM BRANCH
    		if(getComponents(itemInfo.get(1)).isEmpty()|| buyAssembledItems==true){ //if item can not be build and has to be bought OR strategy in which every item is bought
    			
    			//AGENT LOOP
    			for(int j=currentAgent; j<myAgents.size();j++){ //for all agents, starting with currentAgent				
    				
    				println("new agent");
    				println("currentAgentNumber=" + currentAgent + " j=" + j);
    				println("current Agent: " + myAgents.get(currentAgent).get(0) + " = myAgent: " + myAgents.get(j).get(0));
    				LinkedList<String> myAgent = myAgents.get(j);
    				println("itemInfo.get(1)=" + itemInfo.get(1));
    				println("itemInfo.get(2)=" + itemInfo.get(2));
    				println(myAgent.get(0) + " currentLoad= " + myAgents.get(currentAgent).get(numberOfTools+7));
    				//if item is consumed check if current agent already bought it
    				println("test:"+itemInfo.get(0));
    				//if(itemInfo.get(0).equals("item")||itemInfo.get(0).equals("consumed")){
    				
    				//NORMAL ITEM BRANCH
    				if(allMyTools.contains(itemInfo.get(1))==false){
    					println("amount:" + amountOfItemPerAgent(itemInfo.get(1),myAgent));
    					
    					int amountInAgent = amountOfItemPerAgent(itemInfo.get(1),myAgent);
    					//check if agent still carries item from other job
    					int amountInItems = 0;
    					for(Vector<String> myItem: allMyItems){
    	        			if(("agent" + getTeam() + myAgent.get(0).substring(1)).equals(myItem.get(0))){
    	        				for(int i=1; i<myItem.size(); i=i+2){
    	        					if(myItem.get(i).equals(itemInfo.get(1))){
    	        						amountInItems = amountInItems + Integer.parseInt(myItem.get(i+1));
    	        					}
    	        				}
    	        			}
    	        		}
    					
    					//AGENT ALREADY HAS ITEM
    					//if(amountOfItemPerAgent(itemInfo.get(1), myAgent)>=1){
    					if(amountInItems>=1){
    					  println("in item branch");
    					  println("number of items needed:" + Integer.parseInt(itemInfo.get(2)));
    					  
    					  //MORE THAN 1 ITEM NEEDED
    					  if(Integer.parseInt(itemInfo.get(2))>1){
    							//println(itemInfo.get(2) + " = " + amountOfItemPerAgent(itemInfo.get(1), myAgent));
    							//if(Integer.parseInt(itemInfo.get(2)) <= amountOfItemPerAgent(itemInfo.get(1), myAgent)){
        						println(itemInfo.get(2)+"="+amountInItems);
        						
        						//AGENT GOT ENOUGH ITEMS
        						if(Integer.parseInt(itemInfo.get(2)) <= amountInItems){
    							
        							//update allMyItems
        							for(Vector<String> myItem: allMyItems){
        	    	        			if(("agent" + getTeam() + myAgent.get(0).substring(1)).equals(myItem.get(0))){
        	    	        				for(int i=1; i<myItem.size(); i=i+2){
        	    	        					if(myItem.get(i).equals(itemInfo.get(1))){
        	    	        						myItem.set(i+1,Integer.toString(amountInItems-Integer.parseInt(itemInfo.get(2))));
        	    	        					}
        	    	        				}
        	    	        			}
        	    	        		}
        							
    							
    								//add deliver job plan (if necessary)
    	    	    				if(currentMaterial.equals("none")){
    	    	    					println("deliver_job=" + jobID);
    	    	    					println(myAgent.get(0) + " currentLoad= " + myAgents.get(currentAgent).get(numberOfTools+7));
    	    	    					Vector<String> secondPlan = new Vector<String>();
    	    	        				secondPlan.add(myAgent.get(0));
    	    	        				secondPlan.add("deliver_job");
    	    	        				secondPlan.add(jobID);
    	    	        				secondPlan.add(storage);
    	    	        				secondPlan.add(itemInfo.get(1));
    	    	        				createPlan(agentPlans, secondPlan);
    	    	        				myAgent.remove(itemInfo.get(1));
    	    	        				myAgent.set(numberOfTools+7, new Integer(getVolumeOfLoad(getSublist(myAgent, numberOfTools+8, myAgent.size()))).toString());    	    				
    	    	        				println("1currentAgent="+myAgents.get(currentAgent));
    	    	        				println(myAgents.get(0) + " currentLoad= " + myAgents.get(currentAgent).get(numberOfTools+7));
    	    	    				}else{
    	    	    					for(int i=0; i< new Integer(itemInfo.get(2)); i++){
    	    	    						//only add item to assemble items but not to agent because he already got it
    	    	    						//myAgent.add(itemInfo.get(1));
    	    								for(LinkedList<String> myAssembleItem: itemsForAssembling){
    	    									if(myAssembleItem.get(0).equals(myAgent.get(0))){
    	    										myAssembleItem.add(itemInfo.get(1));
    	    									}
    	    								}
    	    							}
    	    	    				}
    								
    								println("break1");
    								break;
        						}
        						
        						//AGENT NEEDS MORE ITEMS
        						//mark items the agent already has and update number of items that are still needed
        						
        						//update allMyItems
    							for(Vector<String> myItem: allMyItems){
    	    	        			if(("agent" + getTeam() + myAgent.get(0).substring(1)).equals(myItem.get(0))){
    	    	        				for(int i=1; i<myItem.size(); i=i+2){
    	    	        					if(myItem.get(i).equals(itemInfo.get(1))){
    	    	        						myItem.set(i+1,"0");
    	    	        					}
    	    	        				}
    	    	        			}
    	    	        		}
    							
    							println("need more items");
    							itemInfo.set(2, new Integer(Integer.parseInt(itemInfo.get(2))-amountOfItemPerAgent(itemInfo.get(1),myAgent)).toString());
    						
    					  }else{
    							//only one item is needed, agent already has it, mark the item and continue
    							
    							//update allMyItems
    							for(Vector<String> myItem: allMyItems){
    	    	        			if(("agent" + getTeam() + myAgent.get(0).substring(1)).equals(myItem.get(0))){
    	    	        				for(int i=1; i<myItem.size(); i=i+2){
    	    	        					if(myItem.get(i).equals(itemInfo.get(1))){
    	    	        						myItem.set(i+1,Integer.toString(amountInItems-1));
    	    	        					}
    	    	        				}
    	    	        			}
    	    	        		}
    							
    							//check if agent is already participant, if not, add agent to participants
    							
    							println("bought and participant?");
        						participating = false;
        						for(String participant: participatingAgents){
        							println("bparticipant1");
        							if(participant.equals(myAgent.get(0))){
        								println("bparticipant2");
        								participating = true;
        							}
        						}
        						if(participating==false){
        							println("bparticipant3");
        							participatingAgents.add(myAgent.get(0));
        							LinkedList<String> myAgentItems = new LinkedList<String>();
        							myAgentItems.add(myAgent.get(0));
        							itemsForAssembling.add(myAgentItems);
        						}
        						
        						//add deliver job plan (if necessary)
        	    				if(currentMaterial.equals("none")){
        	    					println("deliver_job=" + jobID);
        	    					println(myAgent.get(0) + " currentLoad= " + myAgents.get(currentAgent).get(numberOfTools+7));
        	    					Vector<String> secondPlan = new Vector<String>();
        	        				secondPlan.add(myAgent.get(0));
        	        				secondPlan.add("deliver_job");
        	        				secondPlan.add(jobID);
        	        				secondPlan.add(storage);
        	        				secondPlan.add(itemInfo.get(1));
        	        				createPlan(agentPlans, secondPlan);
        	        				myAgent.remove(itemInfo.get(1));
        	        				myAgent.set(numberOfTools+7, new Integer(getVolumeOfLoad(getSublist(myAgent, numberOfTools+8, myAgent.size()))).toString());    	    				
        	        				println("2currentAgent="+myAgents.get(currentAgent));
        	        				println(myAgents.get(0) + " currentLoad= " + myAgents.get(currentAgent).get(numberOfTools+7));
        	    				}else{
        	    					for(int i=0; i< new Integer(itemInfo.get(2)); i++){
        	    						//only add item to assemble items but not to agent because he already got it
        	    						//myAgent.add(itemInfo.get(1));
        								for(LinkedList<String> myAssembleItem: itemsForAssembling){
        									if(myAssembleItem.get(0).equals(myAgent.get(0))){
        										myAssembleItem.add(itemInfo.get(1));
        									}
        								}
        							}
        	    				}
        						
    							break;
    						}
    					}
    					
    				}
    				
    				//TOOL BRANCH
    				//else if(itemInfo.get(0).equals("tools")){
    				else if(allMyTools.contains(itemInfo.get(1))){ //if item is a tool check if current agent can use it and if current agent already bought it
    				//if(itemInfo.get(0).equals("tools")){
    					
    					//CHECK IF AGENT CAN USE TOOL
    					println("item is " + itemInfo.get(1));
    					boolean useable = false;
    					boolean bought = false;
    					for(int k=7; k<= numberOfTools+6; k++){
    						println("AgentTools="+myAgent.get(k)+" item="+itemInfo.get(1));
    						if(myAgent.get(k).equals(itemInfo.get(1))){
    							useable = true;
    							break;
    						}
    					}
    					println("useable=" + useable);
    					println("numberOfTools=" + numberOfTools + ", myAgent.size=" + myAgent.size());
    					for(int l= numberOfTools+8; l<myAgent.size();l++){
    						println(myAgent.get(l) + " vs " + itemInfo.get(1));
    						if(myAgent.get(l).equals(itemInfo.get(1))){
    							bought = true;
    							//add currentAgent to participants
        						println("bought and participant?");
        						participating = false;
        						for(String participant: participatingAgents){
        							println("bparticipant1");
        							if(participant.equals(myAgent.get(0))){
        								println("bparticipant2");
        								participating = true;
        							}
        						}
        						if(participating==false){
        							println("bparticipant3");
        							participatingAgents.add(myAgent.get(0));
        							LinkedList<String> myAgentItems = new LinkedList<String>();
        							myAgentItems.add(myAgent.get(0));
        							itemsForAssembling.add(myAgentItems);
        						}
    							break;
    						}
    					}
    					println("bought=" + bought);
    					
    					//GET HELP FROM OTHER PARTICIPANTS (if necessary)
    					if(useable == false){
    						println("not useable, need help of other participants");
    						useable = false;
    						bought = false;
    						for(LinkedList<String> anotherAgent: myAgents){
        						for(String participant: participatingAgents){
        							if(anotherAgent.get(0).equals(participant)){
        		    					for(int k=7; k<= numberOfTools+6; k++){
        		    						if(myAgent.get(k).equals(itemInfo.get(1))){
        		    							useable = true;
        		    							break;
        		    						}
        		    					}
        		    					for(int l= numberOfTools+8; l<myAgent.size();l++){
        		    						if(myAgent.get(l).equals(itemInfo.get(1))){
        		    							bought = true;
        		    							break;
        		    						}
        		    					}
        							}
        						}
    						}
    						
    						//GET ANOTHER AGENT FOR THE TOOL
    						if(useable==false){
        						//if none of the participating agents can use the tool try next agent
        						println(myAgent.get(0) + " usable=false");
        						currentAgent++;
        						println("currentAgentNumber=" + currentAgent);
        						if(currentAgent == myAgents.size()){
        							currentAgent = 0;
        							currentTrip++;
        							counter++;
        							if(counter==2){
        								println("Error! No Agent can use the tool!");
        								writeInLog(getName()+": DivideItems Error: No Agent can use the tool!");
        								return false;
        							}
        							println("currentAgent=" + currentAgent);
        							j = -1;
        							println("j=" + j);
        						}
        						println("currentAgent=" + myAgents.get(currentAgent).get(0));
        						println("currentAgentNumber=" + currentAgent + " j=" + j);
        						println("goto next agent");
        						continue;
    						}
    	    				println(myAgent.get(0) + " usable=true");
    	    				counter = 0;
    					}
    					
    					//CHECK IF NEW AGENT ALREADY HAS TOOL
    					if(bought == true){
    						//if currentAgent has already bought the tool
    						println("bought=true");
    						//add currentAgent to participants
    						println("bought and participant?");
    						participating = false;
    						for(String participant: participatingAgents){
    							println("bparticipant1");
    							if(participant.equals(myAgent.get(0))){
    								println("bparticipant2");
    								participating = true;
    							}
    						}
    						if(participating==false){
    							println("bparticipant3");
    							participatingAgents.add(myAgent.get(0));
    							LinkedList<String> myAgentItems = new LinkedList<String>();
    							myAgentItems.add(myAgent.get(0));
    							itemsForAssembling.add(myAgentItems);
    						}
    						//break;
    						println("number of tool needed:" + Integer.parseInt(itemInfo.get(2)));
    						
    						//MORE THAN 1 TOOL NEEDED
    						if(Integer.parseInt(itemInfo.get(2))>1){
    							println(itemInfo.get(2) + " = " + amountOfItemPerAgent(itemInfo.get(1), myAgent));
    							
    							//AGENT GOT ENOUGH TOOLS
    							if(Integer.parseInt(itemInfo.get(2)) <= amountOfItemPerAgent(itemInfo.get(1), myAgent)){
        							
    								//add deliver job plan (if necessary)
    	    	    				if(currentMaterial.equals("none")){
    	    	    					println("deliver_job=" + jobID);
    	    	    					println(myAgent.get(0) + " currentLoad= " + myAgents.get(currentAgent).get(numberOfTools+7));
    	    	    					Vector<String> secondPlan = new Vector<String>();
    	    	        				secondPlan.add(myAgent.get(0));
    	    	        				secondPlan.add("deliver_job");
    	    	        				secondPlan.add(jobID);
    	    	        				secondPlan.add(storage);
    	    	        				secondPlan.add(itemInfo.get(1));
    	    	        				createPlan(agentPlans, secondPlan);
    	    	        				myAgent.remove(itemInfo.get(1));
    	    	        				myAgent.set(numberOfTools+7, new Integer(getVolumeOfLoad(getSublist(myAgent, numberOfTools+8, myAgent.size()))).toString());    	    				
    	    	        				println("3currentAgent="+myAgents.get(currentAgent));
    	    	        				println(myAgents.get(0) + " currentLoad= " + myAgents.get(currentAgent).get(numberOfTools+7));
    	    	    				}else{
    	    	    					for(int i=0; i< new Integer(itemInfo.get(2)); i++){
    	    								//only add item to assemble items but not to agent because he already got it
    	    	    						//myAgent.add(itemInfo.get(1));
    	    								for(LinkedList<String> myAssembleItem: itemsForAssembling){
    	    									if(myAssembleItem.get(0).equals(myAgent.get(0))){
    	    										myAssembleItem.add(itemInfo.get(1));
    	    									}
    	    								}
    	    							}
    	    	    				}
    								
    								println("break1");
    								break;
        						}
    							
    							//AGENT NEEDS MORE TOOLS
    							//update number of items that are still needed
    							println("need more tools");
    							itemInfo.set(2, new Integer(Integer.parseInt(itemInfo.get(2))-amountOfItemPerAgent(itemInfo.get(1),myAgent)).toString());
    							
    						}else{
    							//ONLY 1 TOOL NEEDED
    							//agent already got 1 tool
    							
    							//add deliver job plan (if necessary)
        	    				if(currentMaterial.equals("none")){
        	    					println("deliver_job=" + jobID);
        	    					println(myAgent.get(0) + " currentLoad= " + myAgents.get(currentAgent).get(numberOfTools+7));
        	    					Vector<String> secondPlan = new Vector<String>();
        	        				secondPlan.add(myAgent.get(0));
        	        				secondPlan.add("deliver_job");
        	        				secondPlan.add(jobID);
        	        				secondPlan.add(storage);
        	        				secondPlan.add(itemInfo.get(1));
        	        				createPlan(agentPlans, secondPlan);
        	        				myAgent.remove(itemInfo.get(1));
        	        				myAgent.set(numberOfTools+7, new Integer(getVolumeOfLoad(getSublist(myAgent, numberOfTools+8, myAgent.size()))).toString());    	    				
        	        				println("4currentAgent="+myAgents.get(currentAgent));
        	        				println(myAgents.get(0) + " currentLoad= " + myAgents.get(currentAgent).get(numberOfTools+7));
        	    				}else{
        	    					for(int i=0; i< new Integer(itemInfo.get(2)); i++){
        	    						//only add item to assemble items but not to agent because he already got it
        	    						//myAgent.add(itemInfo.get(1));
        								for(LinkedList<String> myAssembleItem: itemsForAssembling){
        									if(myAssembleItem.get(0).equals(myAgent.get(0))){
        										myAssembleItem.add(itemInfo.get(1));
        									}
        								}
        							}
        	    				}
    							
    							//there is only one tool needed, break, because agent already got it
    							println("break2");
    							break;
    						}
    					}
    				}
    				
    				//ITEM PROCESSING BLOCK
    				println("old agent");
    				println("current Agent: " + myAgents.get(currentAgent).get(0));
    				println("myAgent:"+ myAgent);
    				
    				println("test: "  + (Integer.parseInt(myAgent.get(5))) + " - " + (Integer.parseInt(myAgent.get(numberOfTools+7))) + " >= " + (Integer.parseInt(itemInfo.get(2))) + " * " + (getVolume(itemInfo.get(1))));
    				println("test: "  + (Integer.parseInt(myAgent.get(5))) + " - " + (Integer.parseInt(myAgent.get(numberOfTools+7))) + "-" + getVolume(currentMaterial)+ " >= " + (Integer.parseInt(itemInfo.get(2))) + " * " + (getVolume(itemInfo.get(1))));
    				println("assembler="+assembler);
    				
    				//CHECK IF AGENT HAS ENOUGH CAPACITY LEFT FOR ALL ITEMS
    				//if agent != assembler : loadCapacity - currentLoad >= amount of item * volume of item, if agent == assembler : loadCapaity - currentLoad - volume of currentMaterial >= amount of item * volume of item
    				if(((myAgent.get(0).equals(assembler)==false)&&(Integer.parseInt(myAgent.get(5)) - Integer.parseInt(myAgent.get(numberOfTools+7)))>= (Integer.parseInt(itemInfo.get(2)) * getVolume(itemInfo.get(1)))) || ((myAgent.get(0).equals(assembler))&&(Integer.parseInt(myAgent.get(5)) - Integer.parseInt(myAgent.get(numberOfTools+7)) - getVolume(currentMaterial))>= (Integer.parseInt(itemInfo.get(2)) * getVolume(itemInfo.get(1)))) ){
						//add item to my Agent
						for(int i=0; i< new Integer(itemInfo.get(2)); i++){
							myAgent.add(itemInfo.get(1));
							for(LinkedList<String> myAssembleItem: itemsForAssembling){
								if(myAssembleItem.get(0).equals(myAgent.get(0))){
									myAssembleItem.add(itemInfo.get(1));
								}
							}
						}
						//current load = current load + amount of item * volume of item
						println("my Agent size=" + myAgent.size());
						myAgent.set(numberOfTools+7, new Integer(getVolumeOfLoad(getSublist(myAgent, numberOfTools+8, myAgent.size()))).toString());
						println("5currentAgent="+myAgents.get(currentAgent));
						//addPlan
						Vector<String> plan = new Vector<String>();
						println("buy" + itemInfo.get(1)+ " " + itemInfo.get(2));
						plan.add(myAgent.get(0));
						plan.add("buy");
						plan.add(itemInfo.get(1));
						println("itemInfo.get(1)=" + itemInfo.get(1));
						plan.add(itemInfo.get(2));
						println("itemInfo.get(2)=" + itemInfo.get(2));
						//plan.add(chooseShop(itemInfo.get(1), workshopForJob));
						plan.add("none");
						plan.add(workshopForJob);
						createPlan(agentPlans, plan);
						currentItem++;
						
						//update participatingAgents
						println("2participant?");
						participating = false;
						for(String participant: participatingAgents){
							println("2participant1");
							if(participant.equals(myAgent.get(0))){
								println("2participant2");
								participating = true;
							}
						}
						if(participating==false){
							println("2participant3");
							participatingAgents.add(myAgent.get(0));
							LinkedList<String> myAgentItems = new LinkedList<String>();
							myAgentItems.add(myAgent.get(0));
							itemsForAssembling.add(myAgentItems);
						}
						
						//add deliver job plan
	    				if(currentMaterial.equals("none")){		
	    					println("deliver_job=" + jobID);
	    					println(myAgent.get(0) + " currentLoad= " + myAgents.get(currentAgent).get(numberOfTools+7));
	    					Vector<String> secondPlan = new Vector<String>();
	        				secondPlan.add(myAgent.get(0));
	        				secondPlan.add("deliver_job");
	        				secondPlan.add(jobID);
	        				secondPlan.add(storage);
	        				secondPlan.add(itemInfo.get(1));
	        				createPlan(agentPlans, secondPlan);
	        				println(myAgent.get(0) + " currentLoad= " + myAgents.get(currentAgent).get(numberOfTools+7));
	        				myAgent.remove(itemInfo.get(1));
	        				myAgent.set(numberOfTools+7, new Integer(getVolumeOfLoad(getSublist(myAgent, numberOfTools+8, myAgent.size()))).toString());    	    				
	        				println("6currentAgent="+myAgents.get(currentAgent));
	        				println(myAgents.get(0) + " currentLoad= " + myAgents.get(currentAgent).get(numberOfTools+7));
	    				}
						break; //jumps out of agent loop, continues with next item
					}else{
						
						//CHECK IF AGENT HAS ENOUGH CAPACITY LEFT FOR ONE ITEM
						//if agent != assembler : loadCapacity - currentLoad >= volume of item, if agent == assembler : loadCapaity - currentLoad - volume of currentMaterial >= volume of item
		    			if(((myAgent.get(0).equals(assembler)==false)&&(Integer.parseInt(myAgent.get(5)) - Integer.parseInt(myAgent.get(numberOfTools+7)))>= (getVolume(itemInfo.get(1)))) || ((myAgent.get(0).equals(assembler))&&(Integer.parseInt(myAgent.get(5)) - Integer.parseInt(myAgent.get(numberOfTools+7)) - getVolume(currentMaterial))>= (getVolume(itemInfo.get(1)))) ){
							
		    				int remainingCapacity = 0;
		    				
		    				if(myAgent.get(0).equals(assembler)){
		    					println("testA");
		    					remainingCapacity = Integer.parseInt(myAgent.get(5)) - Integer.parseInt(myAgent.get(numberOfTools+7)) - getVolume(currentMaterial); //loadCapacity the agent has left including volume of item the agent is going to assemble
		    				}else{
		    					println("testB");
		    					remainingCapacity = Integer.parseInt(myAgent.get(5)) - Integer.parseInt(myAgent.get(numberOfTools+7)); //loadCapacity the agent has left
		    				}
							
							println("remainingCapacity = " + remainingCapacity);
							int amountForAgent = remainingCapacity/getVolume(itemInfo.get(1)); //amount of items the agent can carry
							println("amountForAgent = " + amountForAgent);
							
							//amount of item = amount of item - amountForAgent
    						itemInfo.set(2, new Integer(Integer.parseInt(itemInfo.get(2))-amountForAgent).toString());
    						println("itemInfo.get(2)=" + itemInfo.get(2));

							//add item to my Agent
							for(int i=0; i< new Integer(amountForAgent); i++){
								myAgent.add(itemInfo.get(1));
								for(LinkedList<String> myAssembleItem: itemsForAssembling){
									if(myAssembleItem.get(0).equals(myAgent.get(0))){
										myAssembleItem.add(itemInfo.get(1));
									}
								}
							}
							
							//current load = current load + volume of item
							myAgent.set(numberOfTools+7, new Integer(getVolumeOfLoad(getSublist(myAgent, numberOfTools+8, myAgent.size()))).toString());
							println("7currentAgent="+myAgents.get(currentAgent));
    						//addPlan
    						Vector<String> plan = new Vector<String>();
    						println("buy " + itemInfo.get(1)+ " " + amountForAgent);
    						plan.add(myAgent.get(0));
    						plan.add("buy");
    						plan.add(itemInfo.get(1));
    						println("iteminfo=" + itemInfo.get(1));
    						plan.add(new Integer(amountForAgent).toString());
    						//plan.add(chooseShop(itemInfo.get(1), workshopForJob));
    						plan.add("none");
    						plan.add(workshopForJob);
    						createPlan(agentPlans, plan);
    						currentItem++; //variable not used anymore?!
    						
    						//update participatingAgents
    						participating = false;
    						println("participant?");
    						for(String participant: participatingAgents){
    							println("participant1");
    							if(participant.equals(myAgent.get(0))){
    								println("participant2");
    								participating = true;
    							}
    						}
    						if(participating==false){
    							println("participant3");
    							participatingAgents.add(myAgent.get(0));
    							LinkedList<String> myAgentItems = new LinkedList<String>();
    							myAgentItems.add(myAgent.get(0));
    							itemsForAssembling.add(myAgentItems);
    						}
    						//add deliver job plan
    	    				if(currentMaterial.equals("none")){
    	    					println("deliver_job=" + jobID);
    	    					println(myAgent.get(0) + " currentLoad= " + myAgents.get(currentAgent).get(numberOfTools+7));
    	    					Vector<String> secondPlan = new Vector<String>();
    	        				secondPlan.add(myAgent.get(0));
    	        				secondPlan.add("deliver_job");
    	        				secondPlan.add(jobID);
    	        				secondPlan.add(storage);
    	        				secondPlan.add(itemInfo.get(1));
    	        				createPlan(agentPlans, secondPlan);
    	        				myAgent.remove(itemInfo.get(1));
    	        				myAgent.set(numberOfTools+7, new Integer(getVolumeOfLoad(getSublist(myAgent, numberOfTools+8, myAgent.size()))).toString());    	    				
    	        				println("8currentAgent="+myAgents.get(currentAgent));
    	        				println(myAgents.get(0) + " currentLoad= " + myAgents.get(currentAgent).get(numberOfTools+7));
    	    				}
							
						}
						
						//add items to assembleItems
						println("store items");
						for(String item: currentItems){
							for(LinkedList<String> myAssembleItem: itemsForAssembling){
								if(myAssembleItem.get(0).equals(myAgent.get(0))){
									myAssembleItem.add(item);
								}
							}
						}
						currentItems.clear();
						currentAgent++;
						if(currentAgent == myAgents.size()){
							currentAgent = 0;
							currentTrip++;
						}
					}
				}
    			
    		}else{ //item has to be build
    			println("assembled branch");
    			//ASSEMBLED ITEM BRANCH
    			int itemAmount = new Integer(itemInfo.get(2));
    			println("itemAmount="+itemAmount);
    			for(int i=1; i<= new Integer(itemInfo.get(2));i++){ //build the item as often as it is needed
        			println("next item");
    				//get volume of item and find agent to carry it
        			currentAgent = 0;
        			boolean useable = false;
        			boolean bought = false;
        			
        			//FIND AGENT FOR ITEM
        			for(int a=0; a<myAgents.size(); a++){
        				LinkedList<String> myAgent = myAgents.get(a);
        				println("currentAgent="+myAgents.get(currentAgent));
        				println(myAgents.get(currentAgent).get(0) + " currentLoad= " + myAgents.get(currentAgent).get(numberOfTools+7));
        				
        				//check if item is normal item and if agent already has it
        				//NORMAL ITEM BRANCH
        				if(allMyTools.contains(itemInfo.get(1))==false){
        					println("amount:" + amountOfItemPerAgent(itemInfo.get(1),myAgent));
        					
        					int amountInAgent = amountOfItemPerAgent(itemInfo.get(1),myAgent);
        					//check if agent still carries item from other job
        					int amountInItems = 0;
        					for(Vector<String> myItem: allMyItems){
        	        			if(("agent" + getTeam() + myAgent.get(0).substring(1)).equals(myItem.get(0))){
        	        				for(int j=1; j<myItem.size(); j=j+2){
        	        					if(myItem.get(j).equals(itemInfo.get(1))){
        	        						amountInItems = amountInItems + Integer.parseInt(myItem.get(j+1));
        	        					}
        	        				}
        	        			}
        	        		}
        					
        					for(Vector<String> myItem: allMyItems){
        	        			if(("agent" + getTeam() + myAgent.get(0).substring(1)).equals(myItem.get(0))){
        	        				println("myItems:"+myItem.toString());
        	        			}
        					}
        					
        					//if agent already has item
        					if(amountInItems>=1){
        						bought = true;
        						
        						//update allMyItems
    							for(Vector<String> myItem: allMyItems){
    	    	        			if(("agent" + getTeam() + myAgent.get(0).substring(1)).equals(myItem.get(0))){
    	    	        				for(int j=1; j<myItem.size(); j=j+2){
    	    	        					if(myItem.get(j).equals(itemInfo.get(1))){
    	    	        						myItem.set(j+1,Integer.toString(amountInItems-1));
    	    	        					}
    	    	        				}
    	    	        			}
    	    	        		}
    							
    							for(Vector<String> myItem: allMyItems){
            	        			if(("agent" + getTeam() + myAgent.get(0).substring(1)).equals(myItem.get(0))){
            	        				println("myItems:"+myItem.toString());
            	        			}
            					}
        						
        						break;
        					}
        				}
        				
        				//CHECK IF AGENT HAS ENOUGH CAPACITY LEFT
            			if(((myAgent.get(0).equals(assembler)==false)&&(Integer.parseInt(myAgent.get(5)) - Integer.parseInt(myAgent.get(numberOfTools+7)))>= (getVolume(itemInfo.get(1)))) || ((myAgent.get(0).equals(assembler))&&(Integer.parseInt(myAgent.get(5)) - Integer.parseInt(myAgent.get(numberOfTools+7)) - getVolume(currentMaterial))>= (getVolume(itemInfo.get(1)))) ){	
        					
            				//TOOL BRANCH
            				if(allMyTools.contains(itemInfo.get(1))){
            				//if(itemInfo.get(0).equals("tools")){
            					println("item is " + itemInfo.get(1));
            					useable = false;
            					bought = false;
            					for(int k=7; k<= numberOfTools+6; k++){
            						if(myAgent.get(k).equals(itemInfo.get(1))){
            							useable = true;
            							break;
            						}
            					}
            					for(int l= numberOfTools+8; l<myAgent.size();l++){
            						if(myAgent.get(l).equals(itemInfo.get(1))){
            							bought = true;
            							break;
            						}
            					}
            					if(useable == false){
            						//try next agent
                						println(myAgent.get(0) + " usable=false");
                						currentAgent++;
                						continue;
            						}
            	    				println(myAgent.get(0) + " usable=true");
            					if(bought == true){
            						println("bought=true");
            						if(itemAmount <= amountOfItemPerAgent(itemInfo.get(1), myAgent)){
            							break;
            						}
            					}
            				}
        					assemblerAgent = currentAgent;
        					break;
        				}
        				currentAgent++;
        			}
        			if(currentAgent == myAgents.size()){
        				println("item is too heavy or there is no agent available that can use it");
        				return false;
        			}
        			
        			//CHECK IF AGENT ALREADY HAS ITEM
        			if(bought == true){
        				//if currentAgent has already bought the item
						println("bought=true");
						//update participatingAgents
						participating = false;
						println("participant?");
						for(String participant: participatingAgents){
							println("participant1");
							if(participant.equals(myAgents.get(currentAgent).get(0))){
								println("participant2");
								participating = true;
							}
						}
						if(participating==false){
							println("participant3");
							participatingAgents.add(myAgents.get(currentAgent).get(0));
							LinkedList<String> myAgentItems = new LinkedList<String>();
							myAgentItems.add(myAgents.get(currentAgent).get(0));
							itemsForAssembling.add(myAgentItems);
						}
						
						
						//add deliver job plan (if necessary)
	    				if(currentMaterial.equals("none")){
	    					println("deliver_job=" + jobID);
	    					println(myAgents.get(currentAgent).get(0) + " currentLoad= " + myAgents.get(currentAgent).get(numberOfTools+7));
	    					Vector<String> secondPlan = new Vector<String>();
	        				secondPlan.add(myAgents.get(currentAgent).get(0));
	        				secondPlan.add("deliver_job");
	        				secondPlan.add(jobID);
	        				secondPlan.add(storage);
	        				secondPlan.add(itemInfo.get(1));
	        				createPlan(agentPlans, secondPlan);
	        				myAgents.get(currentAgent).remove(itemInfo.get(1));
	        				myAgents.get(currentAgent).set(numberOfTools+7, new Integer(getVolumeOfLoad(getSublist(myAgents.get(currentAgent), numberOfTools+8, myAgents.get(currentAgent).size()))).toString());    	    				
	        				println("3currentAgent="+myAgents.get(currentAgent));
	        				println(myAgents.get(0) + " currentLoad= " + myAgents.get(currentAgent).get(numberOfTools+7));
	    				}else{
	    					for(int j=0; j< new Integer(itemInfo.get(2)); j++){
								//only add item to assemble items but not to agent because he already got it
	    						//myAgent.add(itemInfo.get(1));
								for(LinkedList<String> myAssembleItem: itemsForAssembling){
									if(myAssembleItem.get(0).equals(myAgents.get(currentAgent).get(0))){
										myAssembleItem.add(itemInfo.get(1));
									}
								}
							}
	    				}
						
	    				if(allMyTools.contains(itemInfo.get(1))==false){
	    					//continue because agent has already got the item
		    				println("continue; agent has already got item");
		    				continue;
	    				}else{
	    					if(Integer.parseInt(itemInfo.get(2)) <= amountOfItemPerAgent(itemInfo.get(1), myAgents.get(currentAgent))){
	    						//continue because agent has already got enough tools
			    				println("continue; agent has already got enough tools");
			    				continue;
	    					}
	    					//more tools needed, assemble new tool
	    				}
	    				
	    				

        			}
        			
        			//DIVIDE ITEMS FOR NEW ITEM
        			println("currentAgent=" + currentAgent);
    				LinkedList<LinkedList<String>> itemComponents = getComponents(itemInfo.get(1));
    				String newMaterial = itemInfo.get(1);
    				if(divideItems(itemComponents, myAgents, agentPlans, currentAgent, currentTrip, workshopForJob, myAgents.get(currentAgent).get(0), newMaterial, jobID, storage)==false){
    					println("job cannot be completed!");
    					return false;
    				}
    				//update participatingAgents
					participating = false;
					println("participant?");
					for(String participant: participatingAgents){
						println("participant1");
						if(participant.equals(myAgents.get(currentAgent).get(0))){
							println("participant2");
							participating = true;
						}
					}
					if(participating==false){
						println("participant3");
						participatingAgents.add(myAgents.get(currentAgent).get(0));
						LinkedList<String> myAgentItems = new LinkedList<String>();
						myAgentItems.add(myAgents.get(currentAgent).get(0));
						itemsForAssembling.add(myAgentItems);
					}
    				//add deliver job plan (if necessary)
    				if(currentMaterial.equals("none")){
    					println("deliver_job=" + jobID);
    					println(myAgents.get(currentAgent).get(0) + " currentLoad= " + myAgents.get(currentAgent).get(numberOfTools+7));
    					Vector<String> secondPlan = new Vector<String>();
        				secondPlan.add(myAgents.get(assemblerAgent).get(0));
        				secondPlan.add("deliver_job");
        				secondPlan.add(jobID);
        				secondPlan.add(storage);
        				secondPlan.add(newMaterial);
        				createPlan(agentPlans, secondPlan);
        				println("new Material=" + newMaterial);
        				println("myAgent= " + myAgents.get(currentAgent));
        				myAgents.get(currentAgent).remove(newMaterial);
        				myAgents.get(currentAgent).set(numberOfTools+7, new Integer(getVolumeOfLoad(getSublist(myAgents.get(currentAgent), numberOfTools+8, myAgents.get(currentAgent).size()))).toString());
        				println("9currentAgent="+myAgents.get(currentAgent));
        				println("myAgent= " + myAgents.get(currentAgent));
        				println(myAgents.get(currentAgent).get(0) + " currentLoad= " + myAgents.get(currentAgent).get(numberOfTools+7));
    				}
    			}
			}
    	}
		
		//ASSEMBLE PLAN BLOCK
    	//distribute assemble plans
    	if(currentMaterial.equals("none")==false){
        	for(String participant: participatingAgents){
        		println("participants: " + participatingAgents.size());
        		for(LinkedList<String> myAgent: myAgents){
        			println("test1");
        			if(myAgent.get(0).equals(participant)){
            			println("test2");
        	    		if(myAgent.get(0) != assembler){
        	    			
        	    			//ASSISTANT BRANCH
        	    			println("test3");
        	    	
    	    				//add assist_assemble plan
    	    				println(myAgent.get(0));
    	    				println("assist_assemble " + currentMaterial+ " " + assembler);
    	    				Vector<String> plan = new Vector<String>();
    	    				plan.add(myAgent.get(0));
    	    				plan.add("assist_assemble");
    	    				plan.add(currentMaterial);
    	    				plan.add(workshopForJob);
    	    				plan.add(assembler);
    	    				createPlan(agentPlans, plan);
    	    				
    	    				//add assistant to the assembler's plan
    	    				for(LinkedList<Vector<String>> plans: agentPlans){ //for all the plans for all the agents (for this job)
    	    		    		println("test");
    	    					if(plans.get(0).get(0).equals(assembler)){ //find the right agent
    	    		    			//check the last plan in the list which should be the corresponding assemble plan
    	    						println(plans.get(plans.size()-1).get(1) + " = assemble && " + plans.get(plans.size()-1).get(2) + " = " + currentMaterial);
    	    		    			if(plans.get(plans.size()-1).get(1).equals("assemble") && plans.get(plans.size()-1).get(2).equals(currentMaterial)){
    	    		    				println("plan size= " + plans.get(plans.size()-1).size());
    	    		    				plans.get(plans.size()-1).add(myAgent.get(0)); //name of the assistant
    	    		    				println("plan size= " + plans.get(plans.size()-1).size());
    	    		    				println("added assistant");
    	    		    			}
    	    		    		}
    	    				}

    	    				//remove items from myAgent
    	    				println("myAgent size= " + myAgent.size());
        					for(LinkedList<String> myAgentItems: itemsForAssembling){
        						if(myAgentItems.get(0).equals(myAgent.get(0))){
        							for(int i=1; i< myAgentItems.size(); i++){
        								String item = myAgentItems.get(i);
        								println("item:" + item);
        								/*if(item.substring(0,3).equals("too")==false){
        									println("item: " + item);
        									myAgent.remove(item);
        								}*/
        								println("allMyTools contains "+item+":"+allMyTools.contains(item));
        								if(allMyTools.contains(item)==false){
        									println("Assembleitem: " + item);
        									myAgent.remove(item);
        								}
        							}
        						}
        					}
    	    				println("myAgent size= " + myAgents.get(currentAgent).size());
    	    				itemsForAssembling.clear();
    	    				myAgent.set(numberOfTools+7, new Integer(getVolumeOfLoad(getSublist(myAgent, numberOfTools+8, myAgent.size()))).toString()); 
    	    				println("10currentAgent="+myAgents.get(currentAgent));
    	    				
        	    		}else{ //if agent is the assembler
        	    			
        	    			//ASSEMBLER BRANCH
        	    			//add assemble plan
        	    			println("assemble1");
        	    			println(myAgent.get(0));
        	    			println("assemble" + currentMaterial);
        	    			Vector<String> plan = new Vector<String>();
        	    			plan.add(myAgent.get(0));
        	    			plan.add("assemble");
        	    			plan.add(currentMaterial);
        	    			plan.add(workshopForJob);
        	    			createPlan(agentPlans, plan);
        	    			
        	    			println("items for assembling:"+itemsForAssembling);
        	    			
        	    			//remove items from myAgent
        	    			println("myAgent size= " + myAgent.size());
        					for(LinkedList<String> myAgentItems: itemsForAssembling){
        						println("myAgentItems.get(0)="+myAgentItems.get(0)+"=="+myAgent.get(0));
        						if(myAgentItems.get(0).equals(myAgent.get(0))){
        							for(int i=1; i< myAgentItems.size(); i++){
        								String item = myAgentItems.get(i);
        								println("Assembleitem:" + item);
        								/*if(item.substring(0,3).equals("too")==false){
        									println("Assembleitem: " + item);
        									myAgent.remove(item);
        								}*/
        								println("allMyTools contains "+item+":"+allMyTools.contains(item));
        								if(allMyTools.contains(item)==false){
        									println("Assembleitem: " + item);
        									myAgent.remove(item);
        								}
        							}
        						}
        					}
        					println("myAgent size= " + myAgent.size());
        	    			//add new assembled item to myAgent
        	    			myAgent.add(currentMaterial);
        	    			itemsForAssembling.clear();
        	    			//current load = volume of assembled item
        	    			myAgent.set(numberOfTools+7, new Integer(getVolumeOfLoad(getSublist(myAgent, numberOfTools+8, myAgent.size()))).toString());		
        	    			println("11currentAgent="+myAgents.get(currentAgent));
        	    			println("myAgent size= " + myAgent.size());
        	    		}
        			}
        		}
        	}
    	}
    	println("end recursion with material:" + currentMaterial + " and assembler:" + assembler);
    	return true;
    }
    
    public void createPlan(LinkedList<LinkedList<Vector<String>>> agentPlans, Vector<String> parameters){
    	for(LinkedList<Vector<String>> plans: agentPlans){ //for all the plans for all the agents (for this job)
    		if(plans.get(0).get(0).equals(parameters.get(0))){ //find the right agent
    			plans.add(parameters);
    		}
    	}
    }
    
    public void getShopBeliefs(){
    	LinkedList<LinkedList<Parameter>> allMyShops = new LinkedList<LinkedList<Parameter>>(shops);
    	println("All my Shops:");
    	for(LinkedList<Parameter> myShop: allMyShops){
    		println(myShop.get(0));
    	}
    	
    	//sort agents
    	LinkedList<LinkedList<String>> relevantAgents = new LinkedList<LinkedList<String>>(allMyAgents);
    	relevantAgents = sortAgentsByRole(relevantAgents);
    	println("sorted Agents:");
    	for(LinkedList<String> relevantAgent: relevantAgents){
    		println(relevantAgent.get(3) + " " + relevantAgent.get(0));
    	}
    	
    	numberOfShopBeliefs = 0;
    	println("1allMyShops size:" + allMyShops.size());
    	for(int i=allMyShops.size()-1; i>=0; i--){
    		LinkedList<String> myAgent = relevantAgents.get(i);
    		String closestShop = getClosestFacilityGraphHopper(allMyShops, myAgent.get(0));
    		println("write in log");
    		//writeInLog("ShopBelief: "+myAgent.get(0)+"->"+closestShop);
      	   	LogicBelief gotoShop = new LogicBelief("gotoShop", closestShop);
      	   	String sub = "";
    	   	if(myAgent.get(0).length() > 2){
    	   		sub = myAgent.get(0).substring(1, 3);
    	   	}else{
    	   		sub = myAgent.get(0).substring(1, 2);
    	   	}
      	   	if((getTeam() + sub).equals(coordinator)){
      	   		println(myAgent.get(0)+ " add belief");
      	   		addBelief(gotoShop);
      	   	}else{
      	   		println("agent" + getTeam() + sub + " send belief");
      	   		sendMessage(gotoShop,"agent" + getTeam() + sub);
      	   	}
      	   	numberOfShopBeliefs++;
	   		println("5allMyShops size:" + allMyShops.size());
      	   	for(LinkedList<Parameter> myShop: allMyShops){
      	   		println(closestShop + " = " + "facility="+myShop.get(0).toString());
      	   		if(closestShop.equals("facility="+myShop.get(0).toString())){
      	   			println("2allMyShops size:" + allMyShops.size());
      	      	   	allMyShops.remove(myShop);
      	      	   	println("3allMyShops size:" + allMyShops.size());
      	      	   	break;
      	   		}
      	   	}
        	println("4allMyShops size:" + allMyShops.size());
      	   	if(allMyShops.isEmpty()){
      	   		break;
      	   	}
        	println("All my Shops:");
        	for(LinkedList<Parameter> myShop: allMyShops){
        		println(myShop.get(0));
        	}
    		
    	}
    	if(allMyShops.isEmpty()==false){
    		println("There are more shops than agents!");
    	}
    }
    
    //returns list of shops in which the item is available
    public LinkedList<LinkedList<Parameter>> getShopsWithItem(String item){
    	LinkedList<LinkedList<Parameter>> shopsWithItem = new LinkedList<LinkedList<Parameter>>();
    	for(LinkedList<Parameter> myShop: shops){
    		ParameterList availableItems = (ParameterList) myShop.get(3);
    		for(Parameter availableItem: availableItems){
    			LinkedList<String> itemInfo = getInfo(availableItem.toString());
    			if(itemInfo.get(1).equals(item)){
    				shopsWithItem.add(myShop);
    				println(myShop.get(0).toString());
    			}
    		}
    	}
    	if(shopsWithItem.isEmpty()){
    		println("Error! Item cannot be bought!");
    		if(getName().equals("agent" + coordinator)){
	    			writeInLog(getName()+": Item cannot be bought!");
	    		}else{
	    			LogicBelief log = new LogicBelief("log"+getName(), getName()+": Item cannot be bought!");
	    			sendMessage(log, "agent"+coordinator);
	    			println("send Message");
	    		}
    	}
    	return shopsWithItem;
    }
    
    //returns shop in which the item is cheapest
    public String getCheapestShop(LinkedList<LinkedList<Parameter>> shopsWithItem, String item){
    	String cheapestShop = "";
    	int cheapestPrice = 0;
    	for(LinkedList<Parameter> myShop: shopsWithItem){
    		ParameterList availableItems = (ParameterList) myShop.get(3);
    		for(Parameter availableItem: availableItems){
    			LinkedList<String> itemInfo = getInfo(availableItem.toString());
    			println("itemInfo=" + itemInfo);
    			if(itemInfo.get(1).equals(item)){
    				if(Integer.parseInt(itemInfo.get(2)) < cheapestPrice || cheapestPrice == 0){
    					cheapestPrice = Integer.parseInt(itemInfo.get(2));
    					cheapestShop = myShop.get(0).toString();
    				}
    			}
    		}
    	}
    	if(cheapestShop.equals("")){
    		println("Item can not be bought!");
    	}
    	return cheapestShop;
    }
    
    public String chooseShop(String myProduct, String myWorkshop){
    	LinkedList<Parameter> workshopPercept = new LinkedList<Parameter>();
    	for(LinkedList<Parameter> workshop: workshops){
    		if(("facility=" + workshop.get(0).toString()).equals(myWorkshop)){
    			workshopPercept = workshop;
    			println("workshop=" + workshop.get(0));
    			break;
    		}
    	}
    	String myShop = "";
		LinkedList<LinkedList<Parameter>> shopsWithItem = getShopsWithItem(myProduct);
    	if(costsBeforeTime == false){
    		LinkedList<Parameter> destination = new LinkedList<Parameter>();
    		if(nextDestination.equals("workshop")){
    			//myShop = getClosestFacilityToFacilityGraphHopper(shopsWithItem, workshopPercept);
    			destination = workshopPercept;
    		}else{
    			println("workshop=" + workshopPercept);
    			destination = getFacility("facility=" + currentStorage, storages);
    			println("storage=" + destination);
    			//myShop = getClosestFacilityToFacilityGraphHopper(shopsWithItem, myStorage);
    		}
    		
    		//current position
    		Location location1 = new Location(longitude, latitude);
    		
    		//the destination facility
       		double latitude2 = new Double (destination.get(1).toProlog());
            double longitude2 = new Double (destination.get(2).toProlog());
            Location location2 = new Location(longitude2, latitude2);
            
            int shortestRoute = 0;
            LinkedList<Parameter> currentShop = new LinkedList<Parameter>();
        		
        	println("number of shops with item=" + shopsWithItem.size());
        	for (int i=0; i<shopsWithItem.size(); i++){ 
                double latitude3 = new Double (shopsWithItem.get(i).get(1).toProlog());
        		double longitude3 = new Double (shopsWithItem.get(i).get(2).toProlog());
            	Location location3 = new Location(longitude3, latitude3);
                	
            	//from current position to shop
            	Route route2 = cityMap.getNewRoute(location1, location3, perms);
        		int duration2 = route2.getRouteDuration(speed);
            	
        		//from shop to destination
            	Route route3 = cityMap.getNewRoute(location3, location2, perms);
        		int duration3 = route3.getRouteDuration(speed);
            		
        		if((duration2+duration3<shortestRoute && shortestRoute!=0) || (duration2+duration3>shortestRoute && shortestRoute==0)){
        			currentShop = shopsWithItem.get(i);
        			shortestRoute = duration2+duration3;
        			println("shop=" + currentShop.get(0));
        		}
        	}
    		myShop = "facility=" + currentShop.get(0).toString();
    	}else{
    		myShop = "facility=" + getCheapestShop(shopsWithItem, myProduct);
    	}
    	println("shop=" + myShop);
    	return myShop;
    }
    
    //sort agents by role with InsertionSort
    public LinkedList<LinkedList<String>> sortAgentsByRole(LinkedList<LinkedList<String>> unsortedAgents){
    	int numberOfAgents = allMyAgents.size();
    	println("numberOfAgents=" + numberOfAgents);
    	LinkedList<LinkedList<String>> sortedAgents = new LinkedList<LinkedList<String>>(unsortedAgents);
    	LinkedList<String> currentAgent;
    	for(int i=1; i< sortedAgents.size(); i++){
    		currentAgent = new LinkedList<String>(sortedAgents.get(i));
    		int j;
    		for(j = i-1; (j>=0)&&(Integer.parseInt(sortedAgents.get(j).get(4)) < Integer.parseInt(currentAgent.get(4))); j--){
    			sortedAgents.set(j+1, sortedAgents.get(j));
    		}
    		sortedAgents.set(j+1, currentAgent);
    	}
    	return sortedAgents;
    }
    
    //calculates the amount of an item the agent is carrying
    public int amountOfItemPerAgent(String item, LinkedList<String> myAgent){
    	int amount = 0;
    	for(int i = numberOfTools+8; i<myAgent.size(); i++){
    		if(myAgent.get(i).equals(item)){
    			amount++;
    		}
    	}
    	return amount;
    }
    
    
    
    //GraphHopper
    
    //check which facility is closest
    public String getClosestFacilityGraphHopper(LinkedList<LinkedList<Parameter>> facilities){
		println("getClosestFacilityGraphHopper");
    	LinkedList<Parameter> closestFacility = facilities.get(0);
    	Location location1 = new Location(longitude, latitude);
    	
    	//compare distance to closestFacility with distance to next facility from the list
    	for (int i=1; i<facilities.size(); i++){ 		
        	double latitude2 = new Double (closestFacility.get(1).toProlog());
        	double longitude2 = new Double (closestFacility.get(2).toProlog());
        	Location location2 = new Location(longitude2, latitude2);
            double latitude3 = new Double (facilities.get(i).get(1).toProlog());
        	double longitude3 = new Double (facilities.get(i).get(2).toProlog());
        	Location location3 = new Location(longitude3, latitude3);
        	
        	println("perms=" + perms);
        	
        	Route route1 = cityMap.getNewRoute(location1, location2, perms);
        	Route route2 = cityMap.getNewRoute(location1, location3, perms);
    		
    		int duration1 = route1.getRouteDuration(speed);
    		int duration2 = route2.getRouteDuration(speed);
    		
    		if(duration2 < duration1){
    			closestFacility = facilities.get(i);
    		}
    	}
    	println("facility=" + closestFacility.get(0).toString());
    	return "facility=" + closestFacility.get(0).toString();		
    }
    
    //check which facility is closest
    public String getClosestFacilityGraphHopper(LinkedList<LinkedList<Parameter>> facilities, String agent){
		println("getClosestFacilityGraphHopper");
    	LinkedList<Parameter> closestFacility = facilities.get(0);   	
    	Double latitude1 = 0.0;
    	Double longitude1 = 0.0;
        Set<String>	agentPerms = new HashSet<>();
        int agentSpeed = 1;
    	
    	for(LinkedList<String> myAgent: allMyAgents){
    		if(myAgent.get(0).equals(agent)){
    			latitude1 = Double.parseDouble(myAgent.get(1));
    			longitude1 = Double.parseDouble(myAgent.get(2));
    			agentSpeed = Integer.parseInt(myAgent.get(4));
    			if(myAgent.get(3).equals("Drone")){
    	            agentPerms.add("air");
    			}else{
    	            agentPerms.add("road");
    			}
    			break;
    		}
    	}
    	Location location1 = new Location(longitude1, latitude1);
    	
    	//compare distance to closestFacility with distance to next facility from the list
    	for (int i=1; i<facilities.size(); i++){ 
        	double latitude2 = new Double (closestFacility.get(1).toProlog());
        	double longitude2 = new Double (closestFacility.get(2).toProlog());
        	Location location2 = new Location(longitude2, latitude2);
            double latitude3 = new Double (facilities.get(i).get(1).toProlog());
        	double longitude3 = new Double (facilities.get(i).get(2).toProlog());
        	Location location3 = new Location(longitude3, latitude3);
        	
        	Route route1 = cityMap.getNewRoute(location1, location2, agentPerms);
        	Route route2 = cityMap.getNewRoute(location1, location3, agentPerms);
    		
    		int duration1 = route1.getRouteDuration(agentSpeed);
    		int duration2 = route2.getRouteDuration(agentSpeed);
    		
    		if(duration2 < duration1){
    			closestFacility = facilities.get(i);
    			println("closestFacility=" + closestFacility.get(0));
    		}
    	}
    	println("facility=" + closestFacility.get(0).toString());
    	return "facility=" + closestFacility.get(0).toString();		
    }    
    
    //check which facility is closest to another facility
    public String getClosestFacilityToFacilityGraphHopper(LinkedList<LinkedList<Parameter>> facilities, LinkedList<Parameter> facility){
    	println("getClosestFacilityToFacility");
    	LinkedList<Parameter> closestFacility = facilities.get(0);  
    	double latitudeFacility = new Double(facility.get(1).toProlog());
    	double longitudeFacility = new Double(facility.get(2).toProlog());
    	Location location1 = new Location(longitudeFacility, latitudeFacility);
    	
    	//compare distance to closestFacility with distance to next facility from the list
    	for (int i=1; i<facilities.size(); i++){
        	double latitude2 = new Double (closestFacility.get(1).toProlog());
        	double longitude2 = new Double (closestFacility.get(2).toProlog());
        	Location location2 = new Location(longitude2, latitude2);
            double latitude3 = new Double (facilities.get(i).get(1).toProlog());
        	double longitude3 = new Double (facilities.get(i).get(2).toProlog());
        	Location location3 = new Location(longitude3, latitude3);
        	
        	Route route1 = cityMap.getNewRoute(location1, location2, perms);
        	Route route2 = cityMap.getNewRoute(location1, location3, perms);
        	
    		int duration1 = route1.getRouteDuration(speed);
    		int duration2 = route2.getRouteDuration(speed);
     
    		if(duration2 < duration1){
    			closestFacility = facilities.get(i);
    			println("closestFacility=" + closestFacility.get(0));
    		}
    	}
    	println("facility=" + closestFacility.get(0).toString());
    	return "facility=" + closestFacility.get(0).toString();
    }
    
  //generate list of all agents from the team and their properties
    public LinkedList<LinkedList<String>> getListOfAgents(){
    	
    	LinkedList<LinkedList<String>> myAgents = new LinkedList<LinkedList<String>>();
    	LinkedList<String> tmp = new LinkedList<String>();
    	for(int i=0; i<numberOfAgents; i++){
    		myAgents.add(tmp);
    	}
    	
    	for(LinkedList<Parameter> entity: entities){
   		   if(entity.get(1).toString().equals(getTeam())){
   			   LinkedList<String> myAgent = new LinkedList<String>();
   			   myAgent.add(entity.get(0).toString()); 	//name
   			   myAgent.add(entity.get(2).toString());	//latitude
   			   myAgent.add(entity.get(3).toString());	//longitude
   			   myAgent.add(entity.get(4).toString()); 	//role
   			   for(Vector<String> info: roleInfo){		//speed, loadCapacity, batteryCapacity, tools
   				   if(info.get(0).equals(myAgent.get(3))){
   					   for(int i=1; i<4;i++){
   						   myAgent.add(info.get(i));
   					   }
   					   for(int i=0; i<numberOfTools; i++){
   						   //println("test1");
   						   boolean usableTool = false;
   						   for(int j=5;j<=info.size();j++){
   							   if(info.get(j-1).equals(allMyTools.get(i))){
   								   myAgent.add(info.get(j-1));
   								   usableTool = true;
   								   break;
   							   }
   						   }
   						   if(usableTool == false){
   							   myAgent.add("not usable");
   						   }
   					   }
   				   }
   			   }
   			   int currentLoad =0;
   			   myAgent.add(new Integer(currentLoad).toString());
   			   //myAgents.add(myAgent);
   			   myAgents.set(Integer.parseInt(myAgent.get(0).toString().substring(1))-1, myAgent);
   		   }
   	   	}
    	return myAgents;
    }
   	   
   	public LinkedList<LinkedList<LinkedList<String>>> getAgentTeams(LinkedList<LinkedList<String>> myAgents){  
	   LinkedList<LinkedList<LinkedList<String>>> AgentTeams = new LinkedList<LinkedList<LinkedList<String>>>();
   		//sort agents by role
	   LinkedList<LinkedList<String>> sortedAgents = new LinkedList<LinkedList<String>>(myAgents);
	   sortedAgents = sortAgentsByRole(sortedAgents);
	   println("sorted Agents:");
	   for(LinkedList<String> sortedAgent: sortedAgents){
   			   println(sortedAgent.get(3) + " " + sortedAgent.get(0));
   		   }
	   //divide agents into teams
	   int numberOfAgents = sortedAgents.size();
	   int counter=0;
	   while(numberOfAgents > 0){
		   println("counter=" + counter);
		   LinkedList<LinkedList<String>> myAgentTeam = new LinkedList<LinkedList<String>>();
		   myAgentTeam.add(sortedAgents.get(0));
		   myAgentTeam.add(sortedAgents.get((numberOfAgents/4)));
		   myAgentTeam.add(sortedAgents.get((numberOfAgents/4)*2));
		   myAgentTeam.add(sortedAgents.get((numberOfAgents/4)*3));
		   for(LinkedList<String> myAgent: myAgentTeam){
			   sortedAgents.remove(myAgent);
		   }
		   numberOfAgents = sortedAgents.size();
		   if(agentsPerTeam==8){
			   println("8 agents per team");
			   if(counter%2==0){
				   println("add");
				   //myAgentTeams.add(myAgentTeam);
				   AgentTeams.add(myAgentTeam);
			   }else{
				   for(LinkedList<String> myAgent: myAgentTeam){
					   //myAgentTeams.getLast().add(myAgent);
					   AgentTeams.getLast().add(myAgent);
			   		}
			   }
		   }else{
			   println("add2");
			   AgentTeams.add(myAgentTeam);
		   }
		   counter++;
       			   
	   }
	   //println("myAgentTeams=" +  myAgentTeams);
	   for(LinkedList<LinkedList<String>> myAgentTeam: AgentTeams){
		   println("myTeam");
		   println("size=" + myAgentTeam.size());
		   if(myAgentTeam.size()==8){
			   	myAgentTeam = sortAgentsByRole(myAgentTeam);
			   	println("Team:");
			   	println(myAgentTeam.get(0).get(3) + " " + myAgentTeam.get(0).get(0));
			   	println(myAgentTeam.get(1).get(3) + " " + myAgentTeam.get(1).get(0));
			   	println(myAgentTeam.get(2).get(3) + " " + myAgentTeam.get(2).get(0));
			   	println(myAgentTeam.get(3).get(3) + " " + myAgentTeam.get(3).get(0));
		   		println(myAgentTeam.get(4).get(3) + " " + myAgentTeam.get(4).get(0));
		   		println(myAgentTeam.get(5).get(3) + " " + myAgentTeam.get(5).get(0));
		   		println(myAgentTeam.get(6).get(3) + " " + myAgentTeam.get(6).get(0));
		   		println(myAgentTeam.get(7).get(3) + " " + myAgentTeam.get(7).get(0));
		   }else{
			   println("Team:");
			   println(myAgentTeam.get(0).get(3) + " " + myAgentTeam.get(0).get(0));
			   println(myAgentTeam.get(1).get(3) + " " + myAgentTeam.get(1).get(0));
			   println(myAgentTeam.get(2).get(3) + " " + myAgentTeam.get(2).get(0));
			   println(myAgentTeam.get(3).get(3) + " " + myAgentTeam.get(3).get(0));
		   }
	   }
	   println("allMyAgents.size()=" + allMyAgents.size());
	   return AgentTeams;
    }
   	
   	public LinkedList<LinkedList<Parameter>> checkItems(String job, String deliverItem){
   		LinkedList<LinkedList<Parameter>> storeItems = new LinkedList<LinkedList<Parameter>>();
   		LinkedList<Parameter> jobParameter = new LinkedList<Parameter>();
   		ParameterList jobItems = new ParameterList();
   		//get job
   		for(LinkedList<Parameter> pricedJob: pricedJobs){
   			if(pricedJob.get(0).toString().equals(job)){
   				println("found job");
   				jobParameter = pricedJob;
   				jobItems = (ParameterList) pricedJob.get(5);
   				break;
   			}
   		}
   		//check items
   		for(LinkedList<Parameter> item: items){
   			if(item.get(0).toString().equals(deliverItem)){
   				println("item is deliverItem");
   				continue;
   			}else{
   				println("check item");
   				for(Parameter jobItem: jobItems){
   	   				LinkedList<String> jobItemInfo = getInfo(jobItem.toString());
   	   				if(item.get(0).toString().equals(jobItemInfo.get(1))){
   	   					storeItems.add(item);
   	   					println("item has to be stored");
   	   					break;
   	   				}
   	   			}
   			}
   		}
   		
   		return storeItems;
   	}
   	
   	public boolean checkCharge(String myFacilityName, LinkedList<LinkedList<Parameter>> facilities){
   		
   		Location location1 = new Location(longitude, latitude);
   		
   		//the destination facility
   		LinkedList<Parameter> myFacility = getFacility(myFacilityName, facilities);
   		double latitude2 = new Double (myFacility.get(1).toProlog());
        double longitude2 = new Double (myFacility.get(2).toProlog());
        Location location2 = new Location(longitude2, latitude2);
        
        //println("number of chargingstations=" + chargingStations.size());
        
        //the charging station closest to the destination facility
        LinkedList<Parameter> closestChargingStation = getFacility(getClosestFacilityToFacilityGraphHopper(chargingStations, myFacility), chargingStations);
        double latitude0 = new Double (closestChargingStation.get(1).toProlog());
        double longitude0 = new Double (closestChargingStation.get(2).toProlog());
        Location location0 = new Location(longitude0, latitude0);
        	
        println("perms=" + perms);
        Route route1 = cityMap.getNewRoute(location1, location2, perms);
        Route route0 = cityMap.getNewRoute(location2, location0, perms);
    		
    	int duration1 = route1.getRouteDuration(speed);
    	int duration0 = route0.getRouteDuration(speed);
    	int stepsLeft = charge/10;
    	println("duration1+duration0=" + duration1 + " + " + duration0);

    	if(duration0+duration0 >= batteryCapacity/10 && duration1+duration1 >= batteryCapacity/10){
    		if(getName().equals("agent" + coordinator)){
	    		writeInLog(getName()+": cannot reach facility! Distance between "+myFacility.get(0)+" and "+closestChargingStation.get(0)+"="+duration0);
	    	}else{
	    		LogicBelief log = new LogicBelief("log"+getName(), getName()+": cannot reach facility! Distance between "+myFacility.get(0)+" and "+closestChargingStation.get(0)+"="+duration0);
	    		sendMessage(log, "agent"+coordinator);
	    		println("send Message");
	    	}
    	}
    	
    	if(stepsLeft <= duration1+duration0){
    		
    		int shortestRoute = 0;
    		LinkedList<Parameter> myChargingStation = new LinkedList<Parameter>();
    		
    		println("number of chargingstations=" + chargingStations.size());
    		for (int i=0; i<chargingStations.size(); i++){ 
                double latitude3 = new Double (chargingStations.get(i).get(1).toProlog());
            	double longitude3 = new Double (chargingStations.get(i).get(2).toProlog());
            	Location location3 = new Location(longitude3, latitude3);
            	
            	//from current position to charging station
            	Route route2 = cityMap.getNewRoute(location1, location3, perms);
        		int duration2 = route2.getRouteDuration(speed);
        		
        		println("charge/10=" + charge/10);
        		println("chargingStation=" + chargingStations.get(i));
        		println("duration2=" + duration2);
        		if(duration2 > charge/10){
        			continue;
        		}

        		//from charging station to destination
            	Route route3 = cityMap.getNewRoute(location3, location2, perms);
        		int duration3 = route3.getRouteDuration(speed);
        		
        		if((duration2+duration3<shortestRoute && shortestRoute!=0) || (duration2+duration3>shortestRoute && shortestRoute==0)){
        			myChargingStation = chargingStations.get(i);
        			shortestRoute = duration2+duration3;
        			println("chargingStation=" + myChargingStation.get(0));
        		}
        	}
    		if(shortestRoute==0){
    			println("too far from chargingstation!");
    			LogicGoal breakdown = new LogicGoal("breakdown");
    			addMyGoal(breakdown);
    			return false;
    		}else{
    			LogicGoal recharge = new LogicGoal("charge");
    			addMyGoal(recharge);
    			LogicGoal gotoChargingStation = new LogicGoal("goto", "facility=" + myChargingStation.get(0).toString());
    			addMyGoal(gotoChargingStation);
        		println("goto " + myChargingStation);
        		return true;
    		}
    	}else{
    		println("goto " + myFacilityName);
    		return true;
    	}
   	}
   	
   	public LinkedList<Parameter> getFacility(String myFacilityName, LinkedList<LinkedList<Parameter>> facilities){
   		LinkedList<Parameter> myFacility = new LinkedList<Parameter>();
   		for(LinkedList<Parameter> facility: facilities){
			println("facility=" + facility.get(0).toString() + " = " + myFacilityName);
			if(("facility=" + facility.get(0).toString()).equals(myFacilityName)){
				myFacility = facility;
				break;
			}
		}
   		return myFacility;
   	}
   	
   	//log
   	
   	public void writeInLog(String... infos){
   		if(log==true){
   			if(out != null){
   				try {
   					out.write("--Step:"+currentStep);
	            } catch (IOException e) {
	                e.printStackTrace();
	            }
   				for(String info: infos){
   	            	try {
   	                     out.write("----"+info);
   	                     out.write("\n");
   	                     out.flush();
   	                } catch (IOException e) {
   	                     e.printStackTrace();
   	                }
   	            }
   	   		}
   		}
            
   	}
   	
   	public void writeInLog(Vector<String> infos){
   		if(log==true){
   			if(out != null){
   				try {
   					out.write("--Step:"+currentStep);
	            } catch (IOException e) {
	                e.printStackTrace();
	            }
   				for(String info: infos){
   	            	try {
   	                     out.write("----"+info);
   	                     out.write("\n");
   	                     out.flush();
   	                } catch (IOException e) {
   	                     e.printStackTrace();
   	                }
   	            }
   	   		}
   		}
   	}
    
    //goals
    
    public final Stack<LogicGoal> getMyGoalBase(){
		return this.myGoals;
	}
    
    protected void removeMyGoal(){
		myGoals.pop();
	}
    
	public void addMyGoal(LogicGoal goal) {
		myGoals.push(goal);
	}
    
    @Override
    public void handlePercept(Percept p) {}
    
}